/*  assign.c -- decompile assignments, displays, updates etc 
    Copyright (C) 1993  Grant Philip Maizels

    $Header: /usr/src/dp/RCS/assign.c,v 0.6 1995/03/31 10:05:38 gpm Exp $

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

#include "dp.h"

int disass(us a, us t, us f, char *n)
{
    us a2, err;
    char *e, *ae, *when = NULL;
    char *vn;
    us fld, tbl, type;

    err = 0;
    if (t == 0x17)
        t = 7;
    a2 = a;

    dbpf('a', "\n/* %04x +---- mandatory -------+------ optional ------+", a);
    dbpf('a',
	"\n *       expr  atype field dtype destt destv elem 0    expression");
    while(1)
    {
	if (t != (gs(a2+2) & 0xf))
	    dbpf('a', "\n * Type mismatch  hdr %04x dtl %04x", t, gs(a2+2));
	e = gs(a2) == 0 ? "":expr(gs(a2), 0);
	if((gs(a2+2) & 0x80) == 0)
	{
	    ae = gs(a2+12) == 0 ? "":expr(gs(a2+12), 0);
	    dbpf('a', 
		"\n * %04x  %04x  %04x  %04x  %04x  %04x  %04x  %04x %04x %s",
		 a2, gs(a2), gs(a2+2), gs(a2+4), gs(a2+6), gs(a2+8),
		 gs(a2+10), gs(a2+12), gs(a2+14), e);
	    if (gs(a2 + 12) != 0)
		dbpf('a',
		    "\n *   [array index]                               %s", ae);
	}
	else
	    dbpf('a',
		"\n * %04x  %04x  %04x  %04x  %04x                        %s",
		 a2, gs(a2), gs(a2+2), gs(a2+4), gs(a2+6), e);
	if (gs(a2+4) == 0xb1de)
	{
	    propf("%s%s", n, "^");
	    if((gs(a2+2) & 0x80) == 0)
		a2 += 16;
	    else
		a2 += (dos?6:8);
	    continue;
	}
	if ((gs(a2+2) & 0x267f) == 0)
	    break;
	    dbpf('a', "\n */\n");
	    /* print variable names with vname -- assign, message set */
	if (t == 4 || (t == 6 && f == 0xfffe))
	{
	    if(gs(a2+14) == 0)
	       fixv(gs(a2+8), gs(a2+10), NULL, gb(gs(a2)), -gs(a2+14),
		   0, 0, "assign/mes set");
	    if (gs(a2 + 12) == 0 || gs(a2 + 14) != 0) 
	        propf( gb(gs(a2)+1) == 0x62 || gb(gs(a2)+1) == 0x63 ?
			"%s%s%s%s%s":"%s%s%s %s %s",
		    n,
		    gb(gs(a2)+1) == 0x62? "substring(":
		    gb(gs(a2)+1) == 0x63? "overlay(":"",
		    vname(gs(a2+8), gs(a2+10),gs(a2+14)),
		    gs(a2) == 0 || gb(gs(a2)+1) == 0x62 ||
			gb(gs(a2)+1) == 0x63 ? "":"=",
		    e);
	    else
	        propf( gb(gs(a2)+1) == 0x62 || gb(gs(a2)+1) == 0x63 ?
			"%s%s%s[%s]%s%s":"%s%s%s[%s] %s %s",
		    n,
		    gb(gs(a2)+1) == 0x62? "substring(":
		    gb(gs(a2)+1) == 0x63? "overlay(":"",
		    vname(gs(a2+8), gs(a2+10) ,gs(a2+14)),
		    ae, 
		    gs(a2) == 0 || gb(gs(a2)+1) == 0x62 ||
			gb(gs(a2)+1) == 0x63 ? "":"=",
		    e);
	}

	    /* print expressions -- display, update */
	if (t == 1 || t == 0x81 || t == 7) 
	    if (gs(a2+2) != 0x90) 
	    {
		propf("%s%s%s", n, 
		    gs(a2+2) == 0x801 ? "VVV @ ":"",
		    e);
		if (when != NULL)
		    propf("%s", when);
		if (gs(a2+2) == 1)
		    propf(" @ %s", fvname(f, gs(a2+ 4)));
		when = NULL;
		/* map variable names for display*/
		if (gs(a2+2) == 0x81)
		{
		    fld = 0;
		    /* get */
		    if ((gb(gs(a2)+1) & 0xff) == 0x22)
		    {
			tbl = gs(gs(a2) + 4);
			fld = gs(gs(a2) + 6);
			type = gb(gs(a2));
			vn = fvname(f, gs(a2+ 4));
		    }
		    /* array */
		    if ((gb(gs(a2)+1) & 0xff) == 0x34)
		    {
			tbl = gs(gs(a2) + gs(gs(a2)+2));
			fld = gs(gs(a2) + gs(gs(a2)+2) + 2);
			type = gb(gs(a2));
			vn = sfvname(f, gs(a2+ 4));
		    }
		    if (fld != 0 && tbl < 2)
			fixv(tbl, fld, vn, type, 0, 0, 0, "disp/upd");
		}
	    }
	    else
	        when = mpf("%s    when %s", n, e);
	if (f < 1024 & (gs(a2+2) == 7 || gs(a2+2) == 4))
		fixv(gs(a2+8), gs(a2+10), sfvname(f,gs(a2+4)), gb(a2+6),
		    0, 0, 0, "update/assign");
	if (gs(a2+2) == 0x801)
	   propf(" %s", fvname(f, gs(a2+4)));
	if (gs(a2+2) == 0x801)
	   propf(" format \"%s\"", p + gs(a2+12));
	if (t == 2 || (t == 6 && f != 0xfffe) || t == 8 || t == 0x20 ||
	    gs(a2+2) == 0xc0)
	   propf("%s%s", n, fvname(f, gs(a2+4))); 
	fflush(stdout);
	if (err == 1) 
	    propf(" * funny error\n");
	dbpf('a', "\n/*");
	if((gs(a2+2) & 0x80) == 0)
	    a2 += 16;
	else
	    a2 += (dos?6:8);
    }
    dbpf('a', "\n */\n");
}
