/*  const.c -- convert raw data to progress constants 
    Copyright (C) 1993  Grant Philip Maizels

    $Header: /usr/src/dp/RCS/const.c,v 0.6 1995/03/31 10:05:45 gpm Exp $

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

#include "dp.h"

#define BASEYR -4713


char *character(us l, us a)
{
    char buf[4096], buf2[20], *ptr;
    us i;
    int c;
    buf[0] = '\0';

    i = 0;
    while (i < l)
    {
        c = (p + a)[i++];
        if (c == '\\')
        {
	   strcat(buf, "~\\");
	   continue;
	}
        if (c == '"')
        {
	   strcat(buf, "~\"");
	   continue;
	}
        if (c == '~')
        {
	   strcat(buf, "~~");
	   continue;
	}
        if (c == '{')
        {
	   strcat(buf, "~{");
	   continue;
	}
        if (c == '}')
        {
	   strcat(buf, "~}");
	   continue;
	}
        if (c == '\t')
        {
	   strcat(buf, "~t");
	   continue;
        }
        if (c == '\n')
        {
	   strcat(buf, "~n");
	   continue;
	}
        if (c == '\f')
        {
	   strcat(buf, "~f");
	   continue;
	}
        if (c == '\r')
        {
	   strcat(buf, "~r");
	   continue;
	}
        if (c == '\b')
        {
	   strcat(buf, "~b");
	   continue;
	}
        if (c == '\033')
        {
	   strcat(buf, "~E");
	   continue;
	}
	if (c < ' ' || c > '~')
	{
	   sprintf(buf2,"~%03o", c);
	   strcat(buf, buf2);
	   continue;
	}
	buf2[0] = c; buf2[1] = '\0';
	strcat(buf, buf2);
    }
    ptr = (char *) malloc(strlen(buf) + 4);
    if (ptr == NULL) 
	faterror("No memory for character");
    sprintf(ptr, "\"%s\"", buf);
    return(ptr);
}

char *ilogical(us l, us a)
{
    us i = 0;
    long v = 0;
    while(i < l)
       v = (v * 256) + gb(a + i++); 
    return(v==0?"false":"true");
}

char *idate(us l, us a)
{
    us i = 0;
    long v = 0;
    if (gb(a) < 0 || gb(a) > 127)
	v = 0xffffffff;
    while(i < l)
       v = (v * 256) + gb(a + i++); 
    return(date(v + 2433405));
}

char *date(long d)
{
    char *ptr;
    int year;
    unsigned short day, month, yd, md;
    year = BASEYR;
    month = 1;
    if (d > 0)
    {
	while (d > 0)
	{
	    yd = yeardays(year);
	    d -= yd;
	    year++;
	    if (year == 1)
		year++;
	}
	d += yd;
	year--;
    }
    else
    {
	while (d <= 0)
	{
	    year--;
	    yd = yeardays(year);
	    d += yd;
	}
    }
    while (d > 0)
    {
	md = mondays(year, month);
	d -= md;
	month++;
    }
    d += md;
    month--;
    day = (us) d;
    if (year == 1582 && month == 10 && day > 4)
	day -= 10;
     
    ptr = (char *) malloc(12);
    if (ptr == NULL) 
	faterror("No memory for date");
    sprintf(ptr, "%02d/%02d/%s%04d", month, day, year > 0?"":"-", abs(year));
    return(ptr);
}

int mondays(int y, int m)
{
    if (m == 1) return (31);
    if (m == 2 && yeardays(y) == 366) return (29);
    if (m == 2) return (28);
    if (m == 3) return (31);
    if (m == 4) return (30);
    if (m == 5) return (31);
    if (m == 6) return (30);
    if (m == 7) return (31);
    if (m == 8) return (31);
    if (m == 9) return (30);
    if (m == 10 && y == 1582) return (21);
    if (m == 10) return (31);
    if (m == 11) return (30);
    if (m == 12) return (31);
    return(0); /* bad */
}

int yeardays(int y)
{
    if (y == 1582)  /* I thought this should be 11 days in 1752, sept 3-13 */
	return(355);
    if (y > 0 && y < 1600)
    {
	if (y % 4 == 0)
	   return(366);
	else
	   return(365);
    }
    if (y > 0)
    {
	if (y % 4 == 0 && (y % 100 > 0 || y % 400 == 0))
	   return(366);
	else
	   return(365);
    }
    y = -(y + 1);
    if (y % 4 == 0)
       return(366);
    else
       return(365);
}

char *iinteger(us l, us a)
{
    us i = 0;
    long v = 0;

    if (gb(a) < 0 || gb(a) > 127)
	v = 0xffffffff;
    while(i < l)
       v = (v * 256) + gb(a + i++); 
    return(mpf("%ld", v));
}

char *integer(us a)
{
    char *ptr;
    ptr = (char *) malloc(12); /* longest number - 2^31, 11 characters */
    if (ptr == NULL) 
	faterror("No memory for integer");
    sprintf(ptr, "%ld", gl(a));
    return(ptr);
}

char *idecimal(us l, us a)
{
    char *ptr, val[53]; /* 50 digit max, - sign, dec pnt, null */
    us deci, dig, i;

    ptr = val;
    if ((gb(a) & 0x80) == 0)
	*(ptr++) = '-';
    deci = gb(a) & 0x7f;
    dig = (l - 1) * 2;
    if ((gb(a + l - 1) & 0xf) == 0xf)
	dig--;
    for (i=0; i<dig; i++)
    {
	*(ptr++) = (i%2==0?gb(a+1+i/2)>>4:gb(a+1+i/2)&0xf)+'0';
	if(i + 1 == dig - deci && deci > 0)
	    *(ptr++) = '.';
    }
    *ptr = '\0';
    return(mpf("%s", val));
}

char *decimal(us a)
{
    us sign, len, decs;
    int i = 0;
    char *ptr, *p;

    sign = (us) gb(a);
    len = (us) gb(a + 1);
    decs = (us) gb(a + 2);
    ptr = (char *) malloc(len + 3);
    if (ptr == NULL) 
	faterror("No memory for decimal");
    p = ptr;
    if (sign == 0)
        *p++ = '-';
    while(i < len)
    {
 	*p++ = gb(a + 3 + i++) + '0';
	if (len - i == decs)
	    *p++ = '.';
    }
    *p = '\0';
    return(ptr);
}
