/*  dp.c -- decompile progress programs 
    Copyright (C) 1993  Grant Philip Maizels

    $Header: /usr/src/dp/RCS/dp.c,v 0.6 1995/03/31 10:05:45 gpm Exp $

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

#include <fcntl.h>
#include <time.h>
#include "dp.h"

int v, byteswapped, dos, doprnt, loop_ctl, pass;
int Ldebug, lflag, hdump, idump, sdebug, edebug, adebug, fdebug, dbp1;
int TestMode, Vdebug, vdebug, tdebug, Sdump;
int list_all_var, ignfaterr;
us  dumpon;
us  ind_lev;
char *hdumps;
int all_colour, db_dot, file_dot, numflds, brackets, dropuid;
int curr_blk;
char *progname, *propath, *dlc;
unsigned char prog[65536];
char *recid;
char keylbl[1024][16];
/* int  vnhwm, vuhwm; */ /* what the hell are these FIXME: high water marks! */
us vmax;
us tlist, ngsvlist, nsvlist, vlist, fvilist;
us ilist;
/* us unk; */
us pend;
us expr_idx, expr_tbl;
char **macros;
unsigned char *p, *r;

struct block *blkhead;
struct fld **vnlist, **vulist, **vslist, **vflist;
#ifdef TEST
struct frm *flist;
#endif /* TEST */
struct db *dbhead;
struct s_exprs exprs[256];

main(int argc, char *argv[])
{
    int fd, n, c;

    extern char *optarg;
    extern int  optind /* , opterr */ ;
    time_t now;

    pass = 0;
    progname = argv[0];
    propath = getenv("PROPATH");
    dlc = getenv("DLC");
    lflag = Ldebug = TestMode = Vdebug = vdebug = idump = hdump = adebug = 
	fdebug = dbp1 = tdebug = sdebug = edebug = db_dot = file_dot =
	numflds = brackets = dropuid = list_all_var = ignfaterr =
	all_colour = 0;
    Sdump = dumpon = 0;
    v = 6;
    dos = byteswapped = 0;
    doprnt = 1;

    while ((c = getopt(argc, argv, "ABDFNPTUVbcfid:S:v:h:")) != EOF)
    {
        switch (c)
        {
            case 'v' :
		if (optarg[0] != '\0')
		    v = optarg[0] - '0';
                break;
            case 'S' :
		if (optarg[0] != '\0')
		    dumpon = (us) strtol(optarg, (char **)NULL, 16);
		    Sdump = 1;
		    printf("/* dump on at %04x */\n", dumpon);
                break;
            case 'd' :
		if (strchr(optarg, 'A') != NULL)
		    Ldebug = lflag = vdebug = adebug = fdebug =
		    tdebug = sdebug = edebug = 1;
		if (strchr(optarg, '1') != NULL)
		    dbp1 = 1;
		if (strchr(optarg, 'L') != NULL)
		    Ldebug = 1;
		/* Option -T is for turning on testing modes */
		if (strchr(optarg, 'T') != NULL) 
		    TestMode = 1;
		if (strchr(optarg, 'V') != NULL)
		    Vdebug = 1;
		if (strchr(optarg, 'a') != NULL)
		    adebug = 1;
		if (strchr(optarg, 'e') != NULL)
		    edebug = 1;
		if (strchr(optarg, 'f') != NULL)
		    fdebug = 1;
		if (strchr(optarg, 'l') != NULL)
		    lflag = 1;
		if (strchr(optarg, 's') != NULL)
		    sdebug = 1;
		if (strchr(optarg, 't') != NULL)
		    tdebug = 1;
		if (strchr(optarg, 'v') != NULL)
		    vdebug = 1;
                break;
            case 'b' :
                db_dot = 1;
                break;
            case 'c' :
                all_colour = 1;
                break;
            case 'f' :
                file_dot = 1;
                break;
            case 'A' :
		list_all_var = 1;
                break;
            case 'B' :
		brackets = 1;
                break;
            case 'D' :
		dos = 1;
                break;
            case 'F' :
		ignfaterr = 1;
                break;
            case 'N' :
                numflds = 1;
                break;
            case 'P' :
                prntcmd();
		exit(0);
                break;
            case 'U' :
		dropuid = 1;
                break;
            case 'V' :
                printf("%s\n", version);
		exit(0);
                break;
            case 'i' :
                idump = 1;
                break;
            case 'h' :
		hdumps = optarg;
                hdump = 1;
                break;
        }
    }
    if (argc - optind < 1)
	usage();
    
    fd = open(argv[optind], O_RDONLY);
    if (fd == -1)
    {
	faterror("%s: file %s not found\n", "dp", argv[optind]);
	exit(3);
    }
    r = prog;
    while ((n = read(fd, r, 512)) > 0)
	r += n;
    if (hdump)
	printf("Super Header\n");
    p = prog;
    if (gl(0) != 0x56ced309)
    {
	if (gl(0) == 0x09d3ce56)
            byteswapped = 1;
	else
	{
	    faterror("Not a progress R-code file\n");
	    exit(2);
        }
    }
    fprintf(stderr, "running dp on %s\n", argv[optind]);
    p = prog + 68;
    printf("/*************************************************************\n");
    printf(" *\n");
    if (byteswapped)
        printf(" * Byteswapped\n");
    printf(" * generated by %s\n", version);
    printf(" * from %s\n", argv[optind]);
    printf(" * Progress version %d\n", v);
    printf(" * %d bytes read\n", (int)r - (int)prog);
    time(&now);
    printf(" * Compiled on %s", ctime((time_t *) (prog + 4)));
    printf(" * Decompiled on %s", ctime(& now));
    if(lflag)
	d_hdr();
    printf(" *\n");
    printf(" ************************************************************/\n");
    tlist = gs(TLIST);
    ngsvlist = gs((us) NGSVLIST);
    nsvlist = gs((us) NSVLIST);
    vlist = gs((us) VLIST);
    fvilist = gs((us) FVILIST);
/*    unk = gs((us) ILIST); */
    ilist = gs((us) ILIST);
    /* ilist = gs(unk + 6); */	/* this looks a bit like a special case */
    pend = (us) gl(END); /** special case END is -ve **/
#ifdef TEST 
    flist = malloc(sizeof(struct frm) * gs(FRMCNT));
    memset(flist, 0, sizeof(struct frm) * gs(FRMCNT));
#endif
    vmax = cntv(vlist) + 2;
    vnlist = malloc(sizeof(struct fld *) * vmax);
    vnlist = malloc(sizeof(struct fld *) * vmax);
    vulist = malloc(sizeof(struct fld *) * vmax);
    vslist = malloc(sizeof(struct fld *) * vmax);
    vflist = malloc(sizeof(struct fld *) * vmax);
    memset(vnlist, 0, sizeof(struct fld *) * vmax);
    memset(vulist, 0, sizeof(struct fld *) * vmax);
    memset(vslist, 0, sizeof(struct fld *) * vmax);
    memset(vflist, 0, sizeof(struct fld *) * vmax);
    if (vnlist == NULL || vulist == NULL || vslist == NULL || vflist == NULL)
	faterror("No memory for lists");
    if (lflag)
	printf("/* vmax = %d */\n", vmax);

    /* load expression and key data */
    ldexpr();
    ldkey();
    listparam(gs(IPARAM), "input paramater ");
    listparam(gs(OPARAM), "output paramater ");
    if (lflag)
	printf("/*\n");
    dbhead = listdb(gs((us) DBLST));
    listt(tlist);
    listsv(ngsvlist, "new global ");
    listsv(nsvlist, "new ");
    ldfil();
    ldfilwf();
    ldidx();
    ldfld();
    ldidf();
    pass = 1;
    if(gs(HDRPTR) != 0)
    {
	l_disblk(gs(HDRPTR), 0);
	disblk(gs(HDRPTR), 0);
    }
    pass = 0;
    /* look at initial values */
    unchain(ilist, 0);
    fixival();
    fillgaps();
    if (lflag)
	printf(" */\n");
    lists();
    listb(tlist);
    listwf(tlist);
    list_n();
    list_v();
    listf(gs(FRMLST)); /* must be done after pass 0 */
    pass = 2;
    if(gs(HDRPTR) != 0)
	disblk(gs(HDRPTR), 0);
#ifdef TEST
/* this is for testing frame stuff only */
    if (TestMode) for(n = 0; n + 1 < gs(FRMCNT); n++)
    {
	form(n);
	printf("%d FRAME STUFF \n", n);
	printf("    addr <%04x>\n", flist[n].addr);
	printf("    name <%s>\n", flist[n].name);
	printf("    referenced <%d>\n", flist[n].referenced);
	printf("    blk <%d>\n", flist[n].blk);
	printf("    width <%d>\n", flist[n].width);
	printf("    lines <%d>\n", flist[n].lines);
	printf("    row <%s>\n", flist[n].row);
	printf("    column <%s>\n", flist[n].column);
	printf("    down <%s>\n", flist[n].down);
	printf("    scroll <%d>\n", flist[n].scroll);
	printf("    retain <%d>\n", flist[n].retain);
	printf("    labels <%d>\n", flist[n].labels);
	printf("    no_underline <%d>\n", flist[n].no_underline);
	printf("    top_only <%d>\n", flist[n].top_only);
	printf("    overlay <%d>\n", flist[n].overlay);
	printf("    is_down <%d>\n", flist[n].is_down);
	printf("    page_top <%d>\n", flist[n].page_top);
	printf("    no_hide <%d>\n", flist[n].no_hide);
	printf("    no_box <%d>\n", flist[n].no_box);
	printf("    page_bottom <%d>\n", flist[n].page_bottom);
	printf("    color <%s>\n", flist[n].colour);
	printf("    prompt color <%s>\n", flist[n].pcolour);
	printf("    title <%s>\n", flist[n].title);
	printf("    title color <%s>\n", flist[n].tcolour);
	printf("    uv[0] <%04x>\n", flist[n].uv[0]);
	printf("    uv[1] <%04x>\n", flist[n].uv[1]);
	printf("    uv[2] <%04x> (flags)\n", flist[n].uv[2]);
	printf("    uv[3] <%04x>\n", flist[n].uv[3]);
	printf("    uv[4] <%04x>\n", flist[n].uv[4]);
	printf("    uv[5] <%04x> (fixed title pos)\n", flist[n].uv[5]);
	printf("    uv[6] <%04x>\n", flist[n].uv[6]);
	printf("    uv[7] <%04x> (var title wid)\n", flist[n].uv[7]);
	printf("    uv[8] <%04x>\n", flist[n].uv[8]);
	printf("    uv[9] <%04x>\n", flist[n].uv[9]);
    }
/* end. this is for testing frame stuff only */
#endif /* TEST */
    exit(0);
}

