/*  dp.h -- defines and structures
    Copyright (C) 1993  Grant Philip Maizels
    
    $Header: /usr/src/dp/RCS/dp.h,v 0.6 1995/03/31 10:05:49 gpm Exp $

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

#include <stdlib.h>
#include <stdio.h>
#include <string.h>

typedef unsigned short us;

#define NAMELEN		33  /* max name format + null */
#define MAX_LOOPS	1024  /* maximum loops we can decompile in a program */

#define T_CHA		1
#define T_DAT		2
#define T_LOG		3
#define T_INT		4
#define T_DEC		5
#define T_RID		7
#define T_RAW		8

#define L_TYPMSK	7
#define L_PROC		0
#define L_DO		1
#define L_REP		2
#define L_FOR		3
#define L_EDIT		4
#define L_USED		8
#define L_REF		16
#define L_NAMED		32

#define END		-4
#define TLIST   	0x00
#define TCNT    	0x02
#define FRMLST   	0x04
#define FRMCNT		0x06
#define NGSVLIST	0x08
#define H000a		0x0a
#define H000c		0x0c
#define NSVLIST		0x0e
#define HDRPTR		0x10 /* always holds 0x34 */
#define STRLIST		0x12
#define STRCNT		0x14
#define VLIST		0x16
#define SBUFLIST	0x18
#define WFCNT		0x1a
#define SFRAMLIST	0x1c
#define H001e		0x1e
#define FVILIST		0x20
#define DBCNT		0x22
#define DBLST		0x24
#define H0026		0x26
#define H0028		0x28
#define ILIST		0x2a
#define RELEASE		0x2c
#define OPARAM		0x2e
#define IPARAM		0x30
#define BLKHDR		0x34 /* This is the start of a block header for the
			      * entire procedure 44, 0x2c bytes long. 
			      */
#define SOX		0x3e /* commands */
#define SOX5		0x36 
#define REL1		0x42 /* release 1 */
#define REL2		0x48 /* release 2 */
/* #define FRMCNT		0x4c  */
#define YYYYC		0x50 /* 0x50 & 0x52 procedure block properties ??? */
#define YYYYD		0x52
/* next address after header is 0x60 */
#define PROGRESS	0xa9

extern int pass; /* 0 = not passing, 1 = pass1, 2 = pass2 */
extern char version[], loops[], *propath, *dlc;
extern int v, byteswapped, dos, doprnt, loop_ctl;
extern int Ldebug, lflag, hdump, idump, sdebug, edebug, adebug, fdebug, dbp1;
extern int TestMode, Vdebug, vdebug, tdebug, Sdump;
extern int list_all_var, ignfaterr;
extern char *hdumps;
extern int all_colour, db_dot, file_dot, numflds, brackets, dropuid;
extern int curr_blk;
extern unsigned char prog[65536];
extern char *progname;
extern char *recid;
extern char keylbl[1024][16];
/* extern int  vnhwm, vuhwm; */ /* What the hell are these FIX ME */
extern us vmax;
extern us tlist, ngsvlist, nsvlist, vlist, fvilist;
extern us ilist;
extern us unk;
extern us pend;
extern us msgupdfmt;
extern us msgupdar;
extern us expr_idx, expr_tbl;
extern char **macros;
extern int elseif;
extern int for_loop;
extern us dumpon;
extern unsigned char *p, *r;
extern us ind_lev;

void listt(us);
void lists();
void dump(char, int, int);
unsigned char gb(int);
us gs(us);
us cntv(us);
us gettdb(us, us);
us tdb(us);
char *fndpth(char *, char *);
char *expr(us, us);
char *getfvnam(us);
char *vtype(us);
char *fname(us);
char *fldname(us, us);
char *sname(us);
char *tname(us);
char *vname(us, us, us);
char *onfunc(us);
char *fvname(us, us);
char *fvname2(us, us, int);
char *sfvname(us, us);
void fixv(us, us, char *, us, us, us, us, char *);
char *indent();
char *newe(char*, char*);
char *mpf(char *, ...);
void propf(char *, ...);
void dbpf(char, char *, ...);
char *date(long);
char *idate(us, us);
char *character(us, us);
char *ilogical(us, us);
char *integer(us);
char *iinteger(us, us);
char *decimal(us);
char *idecimal(us, us);
char *prostr();
char *aiv(us, us, us);
char *iv(us, us, us);
us   eaiv(us, us);
struct fld *gvbynam(char *);
struct fld *gvbynum(us, us);
struct idx *getidx(us, us);
struct idf *getidf(us, us, us);
struct db *listdb(us);
struct db *getdb_bynum(us);
struct fld *getfld_byrid(us, int);
unsigned long  gl(int);
void ldidf(), ldidx(), ldfld(), ldkey();
void usage();

void d_assign(us);
void d_disblk(us);
void d_hdr();
int disass(us, us, us, char *);
void disblk(us, int);
void l_discmd(us, us);
void l_disblk(us, int);
void l_assign(us);
void l_block(us);
void l_if(us);
void l_loopctl(us);
void l_unchain(us);
void discmd(us, us);
void disput(us);
void dumpdef(struct fld *);
void fillgaps();
void fiv(struct fld ** list);
void fixival();
void form(us fn);
int getfv_bynam(char * name);
void ldexpr();
void ldfil();
void ldfilwf();
void list_n();
void list_v();
void listb(us a);
void listf(us a);
void listf2(us, us, us);
int listf3(us a, us body);
void listparam(us a, char * prefix);
void listsv(us a, char * prefix);
void listwf(us a);
int mondays(int y, int m);
void prntcmd();
void s__trace(us);
void s_apply(us);
void s_assign(us);
void s_bad(us, char *);
void s_block(us);
void s_call(us);
void s_comp(us);
void s_conn(us);
void s_disc(us);
void s_down(us);
void s_eval(us);
void s_find(us);
void s_frame(us);
void s_if(us);
void s_ivalue(us);
void s_loopctl(us);
void s_macro(us);
void s_message(us);
void s_next_prompt(us);
void s_noargs(us);
void s_nop(us);
void s_notdone(us, char *);
void s_on(us);
void s_opsys(us);
void s_output(us);
void s_output_close(us);
void s_page(us);
void s_pause(us);
void s_put(us);
void s_put_cursor(us);
void s_put_screen(us);
void s_readkey(us);
void s_rec(us);
void s_run(us);
void s_scroll(us);
void s_seek(us);
void s_sql1(us);
void s_sql2(us);
void s_status(us);
void unchain(us, int);
void vunchain(us);
int yeardays(int);
void faterror(char *, ...);

struct s_exprs
{
    us   pcount;
    us   preced;
    char fmt[8];
    char txt[16];
};
extern struct s_exprs exprs[256];

struct frmref
{
    struct frmref *next;
};

struct fld
{
    char          *name;    /* name for shared variables */
    us            tnum;     /* number of pseudo table */
    us            fnum;     /* number of pseudo field -- rpos */
    us            recid;
    unsigned      type;     /* character, integer etc */
    unsigned      flags; 
			    /* 01 undo
			       02 no-undo
			       04 array
			       08 case-sensitive
			       10 input param
			       20 output param
			       40 shared variable
			       80 new shared variable
			       c0 new global shared variable */
    unsigned      extent;
    char          *ival;    /* initial value */
    us            ivala;    /* initial value address */
    char          *label;
    char          *clabel;
    struct fld    *next;    /* this has to go */
};


struct idf
{
    char          name[NAMELEN];
    us            idx_seq;
    struct idx    *index;
    struct idf    *next;
};

struct idx
{
    char          name[NAMELEN];
    us            idx_num;
    us            field_cnt;
    struct idf    *idf_head;
    struct file   *file;
    struct idx    *next;
};

struct file
{
    char          name[NAMELEN];
    char          db_tname[NAMELEN];
    us            tnum;
    long          db_filnum;
    long          db_dbnum;
    us            flags;
    struct fld    *fld_head;
    struct idx    *idx_head;
    struct db     *db;
    struct file   *next;
};

struct db
{
    char          name[NAMELEN];
    short         dbnum;
    struct file   *file_head;
    struct db     *next;
};
extern struct block *blkhead;
extern struct fld **vnlist, **vulist, **vslist, **vflist;
extern struct db *dbhead;

struct riop  /* this is used to sort input and output parameters on run */
{
    struct riop  *next;
    us           expr;
    us           flags;  /* 1 input, 2 output, 3 input-output */
    us           tnum;
    us           fnum;
    us           index;
};
#ifdef TEST
struct frm
{
    us	  addr;
    us	  referenced;
    us	  frame;
    us	  blk;
    us    width;
    us    lines;
    us    scroll;
    us    retain;
    us    labels;
    us    no_underline;
    us    top_only;
    us    overlay;
    us    is_down;
    us    page_top;
    us    no_hide;
    us    no_box;
    us    page_bottom;
    us    uv[10]; /* this is very temporary */
    char  *row;
    char  *column;
    char  *down;
    char  *name;
    char  *colour;
    char  *pcolour;
    char  *title;
    char  *tcolour;
/*     struct *frm_det detail; */
};
extern struct frm *flist;
#define LAB_NO   4
#define LAB_TOP  4
#define LAB_SIDE 4
#define LAB_UNK  4
#endif /* TEST */
