/*  dump.c -- dump routines 
    Copyright (C) 1993  Grant Philip Maizels

    $Header: /usr/src/dp/RCS/dump.c,v 0.6 1995/03/31 10:05:46 gpm Exp $

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

#include "dp.h"

void dump(char type, int start, int count)
{
    int i, c, s, e;
    char in[51];

    if (start + count > 0xffffL)
    {
	printf("dumping out of range from %08x for %08x bytes\n", start, count);
	return;
    }
    for (i = 0; i < 50; in[i++] = ' ');
    if (! idump)
	in[1] = '\0';
    else
	in[50] = '\0';

    if (type != 0 && ! hdump)
	return;
    if (type != 0 &&
        strchr(hdumps, 'A') == NULL &&
	strchr(hdumps, type) == NULL)
	return;
    s = (start / 16) * 16;
    e = ((start + count - 1) / 16 + 1) * 16;

    c = s;
    while (c < e)
    {
	if (c % 16 == 0)
	    printf("\n%s%04x - ", in, c);
	if (c % 4 == 0)
	    printf(" ");
	if (c >= start && c < start + count)
	    printf("%02x ", p[c]);
	else
	    printf("   ");
	if (c % 16 == 15)
	{
	    for (i = -15; i <= 0; i++)
		if (i + c >= start && i + c < start + count)
		    if (p[c + i] >= ' ' && p[c + i] <= '~')
			printf("%c", p[c + i]);
		    else
			printf(".");
		else
		    printf(" ");
	}
	c++;
    }
    putchar('\n');
    fflush(stdout);
}

void d_assign(us a)
{
    printf("/* Assignment/display/update/set/prompt-for/import/export...\n");
    printf(" * Address %04x\n", a);
    printf(" * %04x 04 -> list        %04x\n", a+4, gs(a+4));
    printf(" * %04x 06 -> frame       %04x %s\n", a+6, gs(a+6),
	 gs(a+6) == 0xffff?"":fname(gs(a+6)));
    printf(" * %04x 08 -> stream        %02x %s\n", a+8, gb(a+8),
	 gb(a+8) == 0xff?"":sname(gb(a+8)));
    printf(" * %04x 09 -> type          %02x\n", a+9, gb(a+9));
    printf(" * %04x 0a -> edit        %04x\n", a+0xa, gs(a+0xa));
    printf(" * %04x 0c -> go-on       %04x\n", a+0xc, gs(a+0xc));
    printf(" * %04x 0e -> pause       %04x\n", a+0xe, gs(a+0xe));
    printf(" */\n");
    fflush(stdout);
}

void d_disblk(us a)
{
   printf("%s/*\n", indent());
   printf("%s * LI %04x %02x %04x loop number    \n",indent(),a,0,gs(a+0));
   printf("%s * LI %04x %02x %04x loop level     \n",indent(),a+2,2,gs(a+2));
   printf("%s * LI %04x %02x %04x initialization \n",indent(),a+4,4,gs(a+4));
   printf("%s * LI %04x %02x %04x record stuff   \n",indent(),a+6,6, gs(a+6));
   printf("%s * LI %04x %02x %04x ittern control \n",indent(),a+8,8,gs(a+8));
   printf("%s * LI %04x %02x %04x commands       \n",indent(),a+10,10,gs(a+10));
   printf("%s * LI %04x %02x %04x validate       \n",indent(),a+12,12,gs(a+12));
   printf("%s * LI %04x %02x %04x release 1      \n",indent(),a+14,14,gs(a+14));
   printf("%s * LI %04x %02x %04x on endkey      \n",indent(),a+16,16,gs(a+16));
   printf("%s * LI %04x %02x %04x on error       \n",indent(),a+18,18,gs(a+18));
   printf("%s * LI %04x %02x %04x release 2      \n",indent(),a+20,20,gs(a+20));
   printf("%s * LI %04x %02x %04x _______________\n",indent(),a+22,22,gs(a+22));
   printf("%s * LI %04x %02x %04x small val______\n",indent(),a+24,24,gs(a+24));
   printf("%s * LI %04x %02x %04x _______________\n",indent(),a+26,26,gs(a+26));
   printf("%s * LI %04x %02x %04x sflags 1       \n",indent(),a+28,28,gs(a+28));
   printf("%s * LI %04x %02x %04x sflags 2       \n",indent(),a+30,30,gs(a+30));
   printf("%s * LI %04x %02x %04x flags 1        \n",indent(),a+32,32,gs(a+32));
   printf("%s * LI %04x %02x %04x flags 2        \n",indent(),a+34,34,gs(a+34));
   printf("%s * LI %04x %02x %04x _______________\n",indent(),a+36,36,gs(a+36));
   printf("%s * LI %04x %02x %04x _______________\n",indent(),a+38,38,gs(a+38));
   printf("%s * LI %04x %02x %04x _______________\n",indent(),a+40,40,gs(a+40));
   printf("%s * LI %04x %02x %04x _______________\n",indent(),a+42,42,gs(a+42));
   printf("%s */\n", indent());
   fflush(stdout);
}

void d_hdr()
{
    printf(" *\n");
    printf(" * %4d %12s = %04x\n",  END,       "END",       gl(END));
    printf(" * %04x %12s = %04x\n", TLIST,     "TLIST",     gs((us) TLIST));
    printf(" * %04x %12s = %04x\n", TCNT,      "TCNT",      gs((us) TCNT));
    printf(" * %04x %12s = %04x\n", FRMLST,    "FRMLST",    gs((us) FRMLST));
    printf(" * %04x %12s = %04x\n", FRMCNT,    "FRMCNT",    gs((us) FRMCNT));
    printf(" * %04x %12s = %04x\n", NGSVLIST,  "NGSVLIST",  gs((us) NGSVLIST));
    printf(" * %04x %12s = %04x\n", H000a,     "H000a",     gs((us) H000a));
    printf(" * %04x %12s = %04x\n", H000c,     "H000c",     gs((us) H000c));
    printf(" * %04x %12s = %04x\n", NSVLIST,   "NSVLIST",   gs((us) NSVLIST));
    printf(" * %04x %12s = %04x\n", HDRPTR,    "HDRPTR",    gs((us) HDRPTR));
    printf(" * %04x %12s = %04x\n", STRLIST,   "STRLIST",   gs((us) STRLIST));
    printf(" * %04x %12s = %04x\n", STRCNT,    "STRCNT",    gs((us) STRCNT));
    printf(" * %04x %12s = %04x\n", VLIST,     "VLIST",     gs((us) VLIST));
    printf(" * %04x %12s = %04x\n", SBUFLIST,  "SBUFLIST",  gs((us) SBUFLIST));
    printf(" * %04x %12s = %04x\n", WFCNT,     "WFCNT",     gs((us) WFCNT));
    printf(" * %04x %12s = %04x\n", SFRAMLIST, "SFRAMLIST", gs((us) SFRAMLIST));
    printf(" * %04x %12s = %04x\n", H001e,     "H001e",     gs((us) H001e));
    printf(" * %04x %12s = %04x\n", FVILIST,   "FVILIST",   gs((us) FVILIST));
    printf(" * %04x %12s = %04x\n", DBCNT,     "DBCNT",     gs((us) DBCNT));
    printf(" * %04x %12s = %04x\n", DBLST,     "DBLST",     gs((us) DBLST));
    printf(" * %04x %12s = %04x\n", H0026,     "H0026",     gs((us) H0026));
    printf(" * %04x %12s = %04x\n", H0028,     "H0028",     gs((us) H0028));
    printf(" * %04x %12s = %04x\n", ILIST,     "ILIST",     gs((us) ILIST));
    printf(" * %04x %12s = %04x\n", RELEASE,   "RELEASE",   gs((us) RELEASE));
    printf(" * %04x %12s = %04x\n", OPARAM,    "OPARAM",    gs((us) OPARAM));
    printf(" * %04x %12s = %04x\n", IPARAM,    "IPARAM",    gs((us) IPARAM));
    fflush(stdout);
}
