/*  dumpprg.c
    Copyright (C) 1993  Grant Philip Maizels

    $Header: /usr/src/dp/RCS/dumpprg.c,v 0.6 1995/03/31 10:05:46 gpm Exp $

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

#include "dp.h"

void prntcmd()
{
    FILE *fp;
    fp = fopen("dumpfil.p", "w");
    if (fp != NULL)
    {
	fprintf(fp, "/* dumpfil.p */\n");
	fprintf(fp, "output to value(ldbname(\"dictdb\") + \".fil\").\n");
	fprintf(fp, "for each _file:\n");
	fprintf(fp, "    display _file-name _file-num\n");
	fprintf(fp, "        _crc _last-change _numfld\n");
	fprintf(fp, "        with no-box no-labels.\n");
	fprintf(fp, "end.\n");
	fclose(fp);
    }
    fp = fopen("dumpidx.p", "w");
    if (fp != NULL)
    {
	fprintf(fp, "/* dumpidx.p */\n");
	fprintf(fp, "output to value(ldbname(\"dictdb\") + \".idx\").\n");
	fprintf(fp, "for each _index:\n");
	fprintf(fp, "    find _file of _index.\n");
	fprintf(fp, "    display _file-name _index-name _idx-num\n");
	fprintf(fp, "        with no-box no-labels.\n");
	fprintf(fp, "end.\n");
	fclose(fp);
    }
    fp = fopen("dumpfld.p", "w");
    if (fp != NULL)
    {
	fprintf(fp, "/* dumpfld.p */\n");
	fprintf(fp, "output to value(ldbname(\"dictdb\") + \".fld\").\n");
	fprintf(fp, "for each _field:\n");
	fprintf(fp, "    find _file of _field.\n");
	fprintf(fp, "    display _file-name _field-name _field-rpos\n");
	fprintf(fp, "        recid(_field) with no-box no-labels.\n");
	fprintf(fp, "end.\n");
	fclose(fp);
    }
    fp = fopen("dumpidf.p", "w");
    if (fp != NULL)
    {
	fprintf(fp, "/* dumpidf.p */\n");
	fprintf(fp, "output to value(ldbname(\"dictdb\") + \".idf\").\n");
	fprintf(fp, "for each _index:\n");
	fprintf(fp, "    find _file of _index.\n");
	fprintf(fp, "    for each _index-field of _index:\n");
	fprintf(fp, "	     find _field of _index-field.\n");
	fprintf(fp, "	     display _file-name _index-name\n");
	fprintf(fp, "	         _field-name _index-seq\n");
	fprintf(fp, "	         with no-box no-labels width 128.\n");
	fprintf(fp, "    end.\n");
	fprintf(fp, "end.\n");
	fclose(fp);
    }
    fp = fopen("dumpkey.p", "w");
    if (fp != NULL)
    {
	fprintf(fp, "/* dumpkey.p */\n");
	fprintf(fp, "output to value(\"key.lbl\").\n");
        fprintf(fp, "def var a as integer.\n");
        fprintf(fp, "def var i as integer.\n");
        fprintf(fp, "def var l as integer.\n");
        fprintf(fp, "def var kl as character.\n");
        fprintf(fp, "do i = 1 to 16000:\n");
        fprintf(fp, "    assign\n");
        fprintf(fp, "        kl = keylabel(i)\n");
        fprintf(fp, "        l = length(kl)\n");
        fprintf(fp, "        a = asc(kl).\n");
        fprintf(fp, "    if l = 0 then next.\n");
        fprintf(fp, "    if l = 1 then\n");
        fprintf(fp, "    do:\n");
        fprintf(fp, "      if kl = \"~\"\" then kl = kl + kl.\n");
        fprintf(fp, "      if a < 32 or a > 127 then\n");
        fprintf(fp, "        kl = \"~~\" +\n");
        fprintf(fp, "           string(truncate(a / 64, 0), \"9\") +\n");
        fprintf(fp, "           string((truncate(a / 8, 0)) mod 8, \"9\") +\n");
        fprintf(fp, "           string(a mod 8, \"9\").\n");
        fprintf(fp, "        if l = 1 then kl = \"~\"\" + kl + \"~\"\".\n");
	fprintf(fp, "    end.\n");
        fprintf(fp, "    kl = \"~\"\" + kl + \"~\"\".\n");
        fprintf(fp, "    put unformatted i \" \" +  kl skip.\n");
	fprintf(fp, "end.\n");
	fclose(fp);
    }
    fp = fopen("dump.p", "w");
    if (fp != NULL)
    {
	fprintf(fp, "/* dump.p */\n");
	fprintf(fp, "run dumpkey.p.\n");
	fprintf(fp, "run dumpfil.p.\n");
	fprintf(fp, "run dumpfld.p.\n");
	fprintf(fp, "run dumpidx.p.\n");
	fprintf(fp, "run dumpidf.p.\n");
	fclose(fp);
    }
}

