/*  expr.c -- decompile expressions 
    Copyright (C) 1993  Grant Philip Maizels

    $Header: /usr/src/dp/RCS/expr.c,v 0.6 1995/03/31 10:05:46 gpm Exp $

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

#include "dp.h"

char *expr(us a, us prec)
/* us a, prec; */
{
    us i;
    us dtype, pa[6], pl[6];
    char buf[8192], *s;
    struct s_exprs *e;

    e = &(exprs[gb(a+1) & 0xff]);
    dtype = gb(a);
    dbpf('e', "expr: %02x %02x @ %04x %s\n", gb(a+1)&0xff, dtype, a, e->txt);
    buf[0] = '\0';
    if(a == 0)
	return("(Null Expression Address)");
    if(a > pend)
	return("(Illegal Expression Address)");
    if (*e->fmt == 'I') /* Immediate values (Constants) */
    {
	 if (gs(a+8) == 2)
	     return("?");
	 switch (dtype)
	 {
	     case T_CHA:    return(character(gs(a+(dos?10:12)), a+(dos?12:14)));
	     case T_DAT:    return(date((long) gl(a+(dos?10:12))));
	     case T_LOG:    return(gl(a+(dos?10:12))?"true":"false");
	     case T_INT:
	     case T_RID:    return(integer(a+(dos?10:12)));
	     case T_DEC:    if(gb(a+5) == T_DEC)
				return(decimal(a+(dos?10:12)));
			    else
				return(integer(a+(dos?10:12)));
	     case T_RAW:    return("(?? raw - data ??)");
	}
    }
    if (*e->fmt == 'V') /* variables and fields */
    {
	fixv(gs(a+4), gs(a+6), NULL, gs(a+8), e->txt[0] == 'c'?8:0,
	    0, 0, "var ref");
	return(vname(gs(a+4), gs(a+6), 0));
    }
    if (*e->fmt == 'A') /* Arrays */
    {
	fixv(gs(a+gs(a+2)), gs(a+gs(a+2)+2), NULL, dtype, 4, 0, 0, "ar ref");
	return(mpf("%s[%s]", vname(gs(a+gs(a+2)), gs(a+gs(a+2)+2), 0),
	    expr(a + 8 + gs(a+2), 0)));
    }
    if (strchr("bcipCS", *e->fmt) != NULL)
    {
	for(i=0; i<6; i++)
	    pl[i] = pa[i] = 0;
	switch(e->pcount)
	{
	    case 1: pa[0] = a + 4;
		    pl[0] = gs(a+2);
		    break;
	    case 2: pa[0] = a + (dos?6:8);
		    pa[1] = pa[0] + gs(a+2);
		    pl[0] = gs(a+2);
		    pl[1] = gs(a+4);
		    break;
	    case 3: pa[0] = a + 8;
		    pa[1] = pa[0] + gs(a+2);
		    pa[2] = pa[1] + gs(a+4);
		    pl[0] = gs(a+2);
		    pl[1] = gs(a+4);
		    pl[2] = gs(a+6);
		    break;
	    case 4: pa[0] = a + (dos?10:12);
		    pa[1] = pa[0] + gs(a+2);
		    pa[2] = pa[1] + gs(a+4);
		    pa[3] = pa[2] + gs(a+6);
		    pl[0] = gs(a+2);
		    pl[1] = gs(a+4);
		    pl[2] = gs(a+6);
		    pl[3] = gs(a+8);
		    break;
	}
    }
    if (*e->fmt == 'i') /* infix operators */
    {
	if(brackets || prec > e->preced)
	    return(mpf("(%s %s %s)",
		expr(pa[0], e->preced), e->txt, expr(pa[1], e->preced)));
	else if (*(exprs[gb(pa[1] + 1) &0xff].fmt) == 'i' &&
	    exprs[gb(pa[1] + 1) &0xff].preced == e->preced)
	    return(mpf("%s %s (%s)",
		expr(pa[0], e->preced), e->txt, expr(pa[1], e->preced)));
	else
	    return(mpf("%s %s %s",
		expr(pa[0], e->preced), e->txt, expr(pa[1], e->preced)));
    }
    if (*e->fmt == 'p') /* prefixed functions and operators */
    {
	s = mpf("%s%s", (brackets && e->pcount > 0)?"(":"", e->txt);
	for(i=0; i < e->pcount; i++)
	    s = mpf("%s %s", s, expr(pa[i], e->preced));
	s = mpf("%s%s", s, (brackets && e->pcount > 0)?")":"");
	return(s);
    }
    if (*e->fmt == 'b') /* bracketed functions */
    {
	if(dropuid && strcmp(e->txt, "userid") == 0)
	    if(strcmp(exprs[gb(pa[0] + 1) & 0xff].txt, "immed") == 0)
		return("userid");
	s = mpf("%s(", e->txt);
	i = 0;
	for(i = 0; pl[i] != 0; i++)
	    s = mpf("%s%s%s", s, i>0? ", ":"", expr(pa[i], e->preced));
	s = mpf("%s)", s);
	return(s);
    }
    if (*e->fmt == 'r') /* record based expressions */
	return(mpf("%s %s", e->txt, tname(gs(a+4))));
    if (*e->fmt == 'R') /* recid */
	return(mpf("%s(%s)", e->txt, tname(gs(a+4))));
    if (*e->fmt == 'f') /* frame based expressions */
	return(mpf("%s(%s)", e->txt, fname(gs(a+4))));
    if (*e->fmt == 'F') /* input */
	return(mpf("%s frame %s %s",
	    e->txt, fname(gs(a+4)), fvname(gs(a+4), gs(a+6))));
    if (*e->fmt == 'e') /* entered and not entered */
	return(mpf("frame %s %s %s /* %s */", 
	    fname(gs(a+4)), e->txt, fvname(gs(a+4), gs(a+6)), p + a + 10));
    if (*e->fmt == 's') /* stream based expressions */
    {
	if (gs(a+2) == 0)
	    return(mpf("%s", e->txt));
	else
	    return(mpf("%s(%s)", e->txt, sname(gs(a+4))));
    }
    if (*e->fmt == 'C') /* If expression */
	return(mpf("(%s %s then %s else %s)", 
	    e->txt, expr(pa[0], e->preced),
	    expr(pa[1], e->preced), expr(pa[2], e->preced)));
	    
    if (*e->fmt == 'S') /* overlay/substring */
	return(mpf(", %s%s%s) = %s", 
	    expr(pa[1], e->preced), pl[3]==0?"":", ",
	    pl[3] == 0 ?"":expr(pa[3], e->preced),
	    expr(pa[2], e->preced)));
    if (*e->fmt == 'c') /* can-find */
    {
	sprintf(buf, "%s%s where", e->txt, tname(gs(pa[1])), pa[0]);
	for(i=0; i<getidx(gs(pa[0]+4), gs(pa[1]))->field_cnt; i++)
	{
	    if (i != 0)
		strncat(buf, " and", 8192);
	    if(gs(gs(pa[0])) + 8 + (2 * i) != 0)
	    {
		strncat(buf, mpf(" %s = ",
		    getidf(i+1, gs(gs(pa[0])+4), gs(pa[1]))->name), 8192);
		strncat(buf, expr(gs(gs(gs(pa[0])) + 8 + (2 * i)), e->preced),
		    8192);
	    }
	}
	if (gs(pa[0] + 4) < 1025)
	{
	    strncat(buf, mpf(" use-index %s",
		getidx(gs(gs(pa[0])+4), gs(pa[1]))->name), 8192);
	}
	strncat(buf, ")", 8192);
	return(newe(buf, "stmnt expression"));
    }
    if (*e->fmt == 'B') /* Bracketing */
    {
    /*
	if(gs(a+4) > getidx(expr_idx, expr_tbl)->field_cnt)
	    return(mpf("(*** Bad bracket field %d ***)", gs(a+4)));
	if(file_dot)
	    return(mpf("%s.%s", 
		tname(expr_tbl),
		getidf(gs(a+4), expr_idx, expr_tbl)->name));
	else
	    return(getidf(gs(a+4), expr_idx, expr_tbl)->name);
    */
	if(macros == NULL || macros[gs(a+4)] == NULL)
	    return("(*** Bad Macro ***)");
	return(macros[gs(a+4)]);
    }
    return(e->txt);
}
