/*  frame.c -- frames 
    Copyright (C) 1993  Grant Philip Maizels

    $Header: /usr/src/dp/RCS/frame.c,v 0.6 1995/03/31 10:05:47 gpm Exp $

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

#include "dp.h"

void listf(us a)
{
    us a2, i;

    printf("\n/* Forms */\n\n");
    a2 = a;
    i = 0;
    if (a == 0) 
	return;
    while (gl(a2) != 0xffffffff)
    {
	dbpf('f',
        "/* %04x -> %04x %04x %04x %04x %04x %04x:%04x name @ %04x */\n",
	a2, gs(a2), gs(a2+2), gs(a2+4), gs(a2+6), gs(a2+8), gs(a2+10),
	i, gs(gs(a2+6)+0x32));
	listf2(gs(a2 + 6), i, gs(a2 + 2));
	a2 = a2 + 0xc;
	i++;
    }
}

void listf2(us a, us i, us blk) /* dump frame header */
{
    us f1, f2;
    int labels;
    if (a == 0)
	return;
    dump('f', a, 0x34);
    f1 =gb(a+12);
    f2 =gb(a+13);
    printf("form\n");
    dbpf('f', "/*\n");
    /* this is required by new code */
    labels = listf3(a+0x34, 0);

    dbpf('f', " */\n");
    if(gs(a+0x32) == 0)
	printf("    with frame frame%03d-f\n", i);
    else
	printf("    with frame %s\n", p + gs(a+0x32));
    if (gb(a+2) == 1)
	printf("    no-underline\n");
    if (gb(a+2) == 0 && gb(a+29) == 3)
	printf("    no-labels\n");
    if (gb(a+2) == 0 && gb(a+29) == 4)
	printf("    side-labels\n");
    if (gb(a+2) == 0 && gb(a+29) == 0)
	printf("    %s-labels\n", labels?"side":"no");
    if (gs(a+0x16) != 0)
	printf("    %s down\n", expr(a + gs(a + 0x16), 0));
    if (gb(a+3) != 0 && gs(a+0x10) == 0)
	printf("    %d down\n", gb(a + 3));
    if (gb(a+1) != 0)
	printf("/*  %d lines */\n", gb(a + 1));
    if (gs(a+0x12) != 0)
	printf("    row %s\n", expr(a + gs(a + 0x12), 0));
    if (gb(a+4) != 0 && gs(a+0x12) == 0)
	printf("    row %d\n", gb(a + 4));
    if (gs(a+0x14) != 0)
	printf("    column %s\n", expr(a + gs(a + 0x14), 0));
    if (gb(a+5) != 0 && gs(a+0x14) == 0)
	printf("    column %d\n", gb(a + 5));
    if (gb(a+15) != 0)
	printf("    width %d\n", gb(a + 15));
    if ((f1 & 4) == 4)
	printf("    top only\n");
    if ((f1 & 8) == 8)
	printf("    overlay\n");
    if (((f2 & 1) == 1) &&(f2 & 0x20 != 0x20))
	printf("    down ???\n");
    if (f2 == 0x21)
    {
	printf("    down\n");
	f2 = 0;
    }
    if ((f2 & 0x10) == 0x10)
	printf("    page-top\n");
    if ((f2 & 0x20) == 0x20)
	printf("    no-hide\n");
    if ((f2 & 0x40) == 0x40)
	printf("    page-bottom\n");
    if ((f2 & 0x80) == 0x80)
	printf("    no-box\n");
    if (gs(a+0x28) != 0)
	printf("    color value(%s)\n", expr(a + gs(a + 0x28), 0));
    if (gs(a+0x28) == 0 & gs(a+0x26) != 0)
	printf("    color \"%s\"\n", p + a + gs(a+0x26));
    if (gs(a+0x1a) != 0 || gs(a+0x20) != 0)
    {
	printf("    title ");
	if (gs(a+0x1e) != 0)
	    printf(" color value(%s) ", expr(a + gs(a + 0x1e), 0));
	if (gs(a+0x18) != 0 && gs(a+0x1e) == 0)
	    printf(" color \"%s\" ", p + a + gs(a+0x18));
	if (gs(a+0x20) != 0)
	    printf(" %s\n", expr(a + gs(a + 0x20), 0));
	else
	    printf("\"%s\"\n", p + a + gs(a+0x1a));
    }
    printf(".\n");
#ifdef TEST
    /* new code begins here */
    flist[i].addr = a;
    flist[i].frame = i;
    flist[i].referenced = 1;
    flist[i].blk = blk;
    flist[i].labels = labels;
    flist[i].lines = gb(a+1);
    flist[i].width = gb(a+15);
    flist[i].retain = gs(a+10)<32768?gs(a+10):0;
    flist[i].scroll = gs(a+10)>32767?0-gs(a+10):0;
    flist[i].no_underline = (gs(a+2) == 1);
    flist[i].top_only = (f1 & 4 == 4);
    flist[i].overlay = (f1 & 8 == 8);
    flist[i].is_down = (f2 & 0x21 == 0x21);
    flist[i].page_top = (f2 & 0x10 == 0x10);
    flist[i].no_hide = (f2 & 0x20 == 0x20);
    flist[i].page_bottom = (f2 & 0x40 == 0x40);
    flist[i].no_box = (f2 & 0x80 == 0x80);
    flist[i].row = NULL;
    if (gb(a+4) != 0)
	flist[i].row = mpf("%d", gb(a+4), 0);
    if (gs(a+18) != 0)
	flist[i].row = mpf("%s", expr(a +gs(a+18), 0));
    flist[i].column = NULL;
    if (gb(a+5) != 0)
	flist[i].column = mpf("%d", gb(a+5), 0);
    if (gs(a+20) != 0)
	flist[i].column = mpf("%s", expr(a +gs(a+20), 0));
    flist[i].down = NULL;
    if (gb(a+3) != 0)
	flist[i].down = mpf("%d", gb(a+3), 0);
    if (gs(a+22) != 0)
	flist[i].down = mpf("%s", expr(a +gs(a+22), 0));
    if (gs(a+50) != 0)
	flist[i].name = mpf("%s", p +gs(a+50));
    flist[i].colour = NULL;
    if (gs(a+38) != 0)
	flist[i].colour = mpf("\"%s\"", p + a + gs(a+38));
    if (gs(a+40) != 0)
	flist[i].colour = mpf("%s", expr(a + gs(a+40), 0));
    flist[i].pcolour = NULL;
    if (gs(a+44) != 0)
	flist[i].pcolour = mpf("\"%s\"", p + a + gs(a+44));
    if (gs(a+46) != 0)
	flist[i].pcolour = mpf("%s", expr(a + gs(a+46), 0));
    flist[i].title = NULL;
    if (gs(a+26) != 0)
	flist[i].title = mpf("%\"%s\"", p + a + gs(a+26));
    if (gs(a+32) != 0)
	flist[i].title = mpf("%s", expr(a + gs(a+32), 0));
    flist[i].tcolour = NULL;
    if (gs(a+24) != 0)
	flist[i].tcolour = mpf("\"%s\"", p + a + gs(a+24));
    if (gs(a+30) != 0)
	flist[i].tcolour = mpf("%s", expr(a + gs(a+30), 0));
/* unknown structure fields */
    flist[i].uv[0] = gb(a);
    flist[i].uv[1] = gs(a + 8);
    flist[i].uv[2] = gs(a + 12); /* flags */
    flist[i].uv[3] = gb(a + 14);
    flist[i].uv[4] = gs(a+16);
    flist[i].uv[5] = gs(a+28);
    flist[i].uv[6] = gs(a+34);
    flist[i].uv[7] = gs(a+36);
    flist[i].uv[8] = gs(a+42);
    flist[i].uv[9] = gs(a+48);
#endif /* TEST */
}

int listf3(us a, us body)
{
    int labels = 0;

    if (body > 1)
	return(0);
    if (a > pend)
    {
	printf("Access beyond end %04x\n", a);
	return(0);
    }
    if (gs(a+2) == 0 || gs(a+2) >= 0x2000)
	return(0);
    dump('f', a, gs(a+2));
    dbpf('f', "form detail %04x @ %04x\n", gs(a), a);
    if ((gs(a) & 0x7f00) == 0x0000)  /* codes 00xx and 80xx */
    {
	printf("    %s",
	(gs(a+12) == 0xffff ? 
	    (char *) p + vlist - gl(a+12):
	    getfld_byrid((us)gb(a+16), gs(a+14))->name));
	if((gs(a + 16) & 0xff) != 0)
	    printf("[%d]", gs(a+16) & 0xff);
	printf(" /* type %s row %d col %d */ format \"%s\"",
	    vtype(gb(a+6)), gb(a+4), gb(a+5), p + a + 18);
	if(gs(a) & 0x01)
	    printf(" auto-return");
	if(gs(a) & 0x02)
	    printf(" special-02");
	if(gs(a) & 0x04)
	    printf(" attr-space");
	/* this is wrong. It means that the label is in the frame definition. 
	   if it is not set the label comes from the variable defn */
	if(gs(a) & 0x08) 
	    printf(" no-label");
	if(gs(a) & 0x20)
	    printf(" deblank");
	if(gs(a) & 0x40)
	    printf(" blank");
	printf("\n");
    }
    if (gs(a) == 0x0800)		/* fixed text */
    {
	labels = 1;
        printf("        /* Label \"%s\" at row %d column %d */\n",
	    p + a + 8, gb(a+4), gb(a+5));
    }
    if (gs(a) == 0x0802)		/* fixed text */
        printf("        /* Underline \"%s\" at row %d column %d */\n",
	    p + a + 8, gb(a+4), gb(a+5));
    if (gs(a) == 0x0100 && gs(a+4) != 0)		/* validation */
    {
	 printf("        validate (%s, ", expr(gs(a+4), 0));
	 printf("%s)\n", expr(gs(a+6), 0));
    }
    if (gs(a) == 0x0100 && gs(a+8) != 0)		/* help */
	 printf("        help %s\n", character(strlen(p + gs(a+8)), gs(a+8)));
    if (gs(a) == 0x0400)		/* start/end ?? */
	 body++;
    labels |= listf3(a+gs(a+2), body);
    return(labels);
}

void form(us fn)
{
    propf("form\n");
    ind_lev++;
    ind_lev--;
    propf("with\n");
    ind_lev++;
    if (flist[fn].colour != NULL || flist[fn].pcolour != NULL)
    {
	propf("color", flist[fn].title);
	if (flist[fn].colour != NULL)
	    propf(" %s", flist[fn].colour);
	if (flist[fn].pcolour != NULL)
	    propf(" prompt %s", flist[fn].pcolour);
	propf("\n");
    }
    if (flist[fn].column != NULL)
	propf("column %s\n", flist[fn].column);
    if (flist[fn].is_down != 0)
	propf("down\n");
    if (flist[fn].down != NULL)
	propf("%s down\n", flist[fn].down);
    if (flist[fn].name != NULL)
	propf("frame %s\n", flist[fn].name);
    if (flist[fn].no_box)
	propf("no box\n");
    if (flist[fn].no_hide)
	propf("no hide\n");
    if (flist[fn].overlay)
	propf("overlay\n");
    if (flist[fn].page_top)
	propf("page top\n");
    if (flist[fn].page_bottom != 0)
	propf("page bottom\n");
    if (flist[fn].retain != 0)
	propf("retain %d\n", flist[fn].retain);
    if (flist[fn].row != NULL)
	propf("row %s\n", flist[fn].row);
    if (flist[fn].scroll != 0)
	propf("scroll %d\n", flist[fn].scroll);
    if (flist[fn].title != NULL)
    {
	propf("title ", flist[fn].title);
	if (flist[fn].tcolour != NULL && 
	    (all_colour || strcmp(flist[fn].tcolour, "\"messages\"") != 0))
	    propf("color <%s> ", flist[fn].tcolour);
	propf("%s\n", flist[fn].title);
    }
    if (flist[fn].top_only)
	propf("top only\n");
    if (flist[fn].width != 0)
	propf("width %d\n", flist[fn].width);
    if (flist[fn].lines != 0)
	propf("/* lines %d */\n", flist[fn].lines);
    ind_lev--;
    propf(".\n");
}
