/*  lists.c 
    Copyright (C) 1993  Grant Philip Maizels

    $Header: /usr/src/dp/RCS/lists.c,v 0.6 1995/03/31 10:05:48 gpm Exp $

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

#include "dp.h"
#include <time.h>

/* gettdb is local to tdb */

us gettdb(us t, us a) 
{
    dbpf('v', "gettdb(%04x, %04x); %04x\n", t, a, gs(a+2));
    if (gs(a+2) == t)
	return(gs(gs(a+6)+2));
    if(gs(a) == 0)
	return(0);
    return(gettdb(t, gs(a)));
}

/* return the database number given a table number */

us tdb(us t) 
{
    return(gettdb(t, tlist));
}

/* getidf -- return a pointer to a idf structure for index field,
 *	     given index field number, index number and table number
 */

struct idf *getidf(us fn, us i, us t) 
{
    struct idx *idxp;
    struct idf *idfp;
    idxp = getidx(i, t);
    idfp = idxp->idf_head;
    while (idfp != NULL)
    {
	if(idfp->idx_seq == fn)
	    break;
	idfp = idfp->next;
    }
    return(idfp);
}

/* getidx -- return a pointer to a idx structure for an index
 *	     given index number and table number
 */

struct idx *getidx(us i, us t)
{
    struct db *dbp;
    struct file *filep;
    struct idx *idxp;

/* TMP */ printf("getidx %i %i\n", i, t); fflush(stdout);
    dbp = dbhead;
    while (dbp != NULL)
    {
       if (dbp->dbnum == tdb(t))
	   break;
       dbp = dbp->next;
    }
    filep = dbp->file_head;
    while (filep != NULL)
    {
       if (strncmp(filep->name, tname(t), NAMELEN) == 0)
	   break;
       filep = filep->next;
    }
    idxp = filep->idx_head;
    while (idxp != NULL)
    {
       if (idxp->idx_num == i)
	   break;
       idxp = idxp->next;
    }
    return(idxp);
}

/* print definitions for buffers, 
 * must be improved to ignore or handle workfiles
 */

void listb(us a)
{
    struct db *dbp;
    dbp = getdb_bynum(gs(gs(a+6) + 2));
    if (a == 0)
	return;
    if (strncmp((char *) p + gs(a+4),(char *) p + gs(a+10), NAMELEN) != 0)
    {
        propf("define ");
	if((gs(a+12) & 0x80) == 0x80)
	    propf("new ");
	if((gs(a+12) & 1) == 1)
	    propf("shared ");
        propf("buffer %s for ",
	    p + gs(a+10), dbp->name, p + gs(a+4));
	if (db_dot)
	    propf("%s.", dbp->name);
        propf("%s", p + gs(a+4));
	if((gs(a+12) & 2) == 2)
	    propf(" preselect");
	propf(".\n");
    }
    listb(gs(a));
}


void listwf(us a)
{
    struct db *dbp;

    printf("/* Workfiles */\n");
    return;
    dbp = getdb_bynum(gs(gs(a+6) + 2));
    if (a == 0)
	return;
    if (strncmp((char *) p + gs(a+4),(char *) p + gs(a+10), NAMELEN) != 0)
    {
        propf("define ");
	if((gs(a+12) & 0x80) == 0x80)
	    propf("new ");
	if((gs(a+12) & 1) == 1)
	    propf("shared ");
        propf("buffer %s for %s.%s",
	    p + gs(a+10), dbp->name, p + gs(a+4));
	if((gs(a+12) & 2) == 2)
	    propf(" preselect");
	propf(".\n");
    }
    listb(gs(a));
}

/* scan list of tables in r-code and build list for load routines */

void listt(us a) 
{
    struct db *dbp;
    struct file *filep, *filet;
    char *db_tname, *name, *wf_name;
    us tbl, db, sharev, flags, ival, ivcnt, wf_tnum, wf_fldcnt, wf_dbnum;
    long tstamp;

    tbl       = gs(a+2);
    db_tname  = (char *) p + gs(a+4);
    db        = gs(a+6);
    sharev    = gs(a+8);
    name      = (char *) p + gs(a+10);
    flags     = gs(a+12);
    ival      = gs(a+14);
    ivcnt     = gs(a+16);
    wf_tnum   = gs(a+18);
    wf_name   = (char *) p + gs(a+20);
    tstamp    = gl(a+24);
/*     wf_tnum   = gs(a+28); */
    wf_fldcnt = gs(a+30);
    wf_dbnum  = gs(a+32);

    dbp = getdb_bynum(gs(db + 2));
    if (a == 0)
	return;
    if (sharev != 0)	/* shared variables */
	fixv(tbl, 0, (char *) p + gs(sharev+2), gs(sharev+4),
	     0x40 | ((gs((sharev+12)) == 1) ? 0x01 : 0x02) | 
	         (((gs(sharev+8)) == 0) ? 0x00 : 0x04),
	     gs(sharev+8),
	     0, "shared var");
    else
    {
	if (lflag)
	    printf(" * Table %3d %16s %16s db %2d %16s\n",
		tbl,		/* table number */
		db_tname,	/* table name */
		name,		/* table name 2 */
		gs(db+2), 	/* table datbase num */
		dbp->name);
/*
	if (tdebug && lflag)
	    printf(" *         timestamp %08x %s", 
		*((long *)p + tstamp),
		ctime((time_t *) (p + tstamp)));   */ /* table time stamp */
	if (dbp != NULL)
/* 	if (dbp != NULL &&  */
/* 	    strncmp(db_tname, name, NAMELEN) == 0) */
	{
	    filet = dbp->file_head;
	    filep = malloc(sizeof(struct file));
	    if (filet == NULL)
		dbp->file_head = filep;
	    else
	    {
		while(filet->next != NULL)
		    filet = filet->next;
		filet->next =filep;
	    }
	    filep->next = NULL;
	    filep->fld_head = NULL;
	    filep->idx_head = NULL;
            filep->tnum = tbl;
            filep->db_filnum = wf_tnum;
            filep->db_dbnum = wf_dbnum;
            filep->flags = 0;
	    strncpy(filep->name, name, NAMELEN);
	    strncpy(filep->db_tname, db_tname, NAMELEN);
	    filep->db = dbp;
	}
    }
    listt(gs(a));
}

/* Insert a variable into the lists.
 *
 *
 */

void fixv(us t, us f, char *name, us type, us flags, us extent, 
    us ivala, char *whence)
{
    struct fld **list;
    us i;
    int fv;
    struct fld *vp;

    if (pass == 2)
       return;
    if (t > 1 && f > 0)
	return;
    switch (t)
    {
	case 0:  list = vulist; break;
	case 1:  list = vnlist; break;
	default: list = vslist; break;
    }
    if (vdebug)
        printf(
	   "fixv: into %s, t=%03d, f=%03d, %s, flgs=%02x, extent=%d, %s, %s,",
	    (list == vnlist) ?
		"vnlist":((list == vulist) ?
		    "vulist":((list == vslist) ?
			"vslist":"??????")),
	    t, f, vtype(type), flags, extent, name, whence);
    vp = gvbynum(t, f);
    if (vp == NULL && name != NULL)
        vp = gvbynam(name);
    if (vp == NULL)
    {
	if (list == vslist)
	    i = t;
	else
	    i = f;
	list[i] = malloc(sizeof(struct fld));
	vp = list[i];
	vp->type = vp->flags = vp->extent = 0;
	vp->name = NULL;
	vp->ival = NULL;
	vp->ivala = 0;
	vp->tnum = t;
	vp->fnum = f;
	if (vdebug)
	    printf("Created\n");
    }
    else
	if (vdebug)
	    printf("Exists\n");
    if (name != NULL && vp->name != NULL && strcmp(name, vp->name) != 0)
	faterror("Variable name clash var-%d-%d, %s, %s\n",
	    t, f, name, vp->name);
    if (name != NULL)
	vp->name = name;
    if (ivala != 0)
	vp->ivala = ivala;
    if(vp->type != 0 && type != 0 && vp->type != type)
        printf("\n/* Variable type clash  var-%d-%d, %s, was %d, to %d */\n",
	    t, f, vp->name!=NULL?vp->name:"", vp->type, type);
    if (type != 0)
	vp->type = type;
    vp->flags |= flags;
    if (t == 1)
	vp->flags |= 1;
    if (extent > vp->extent)
	vp->extent = extent;
    if (name != NULL)
    {
	fv = getfv_bynam(name);
	if (fv > 0)
	    vflist[fv] = vp;
    }
}

void list_v()
{
    us i;
    printf("\n/* New format variable list by number vmax = %d */\n", vmax);
    printf("\n/* no-undo variables */\n");
    for (i = 2; i < vmax; i++)
	if(vnlist[i] != NULL && vnlist[i]->name == NULL)
	{
	    vnlist[i]->flags |= 1;
	    dumpdef(vnlist[i]);
	}
    printf("\n/* Normal variables */\n");
    for (i = 2; i < vmax; i++)
	if(vulist[i] != NULL && vulist[i]->name == NULL)
	    dumpdef(vulist[i]);
    printf("\n/* shared variables */\n");
    for (i = 2; i < vmax; i++)
	if(vslist[i] != NULL && vslist[i]->name == NULL)
	    dumpdef(vslist[i]);
}

void list_n()
{
    us i;
    printf("/* New format variable list by name vmax = %d */\n", vmax);
    for (i = 2; i < (us)(vmax - 1); i++)
	if(vflist[i] != NULL)
	    dumpdef(vflist[i]);
	else
	    printf("define variable %s as unknown. \n", getfvnam(i));
}

/* list the variable definitions
 */

void dumpdef(struct fld *vp)
{
    printf("/* var-%d-%d */ define ", vp->tnum, vp->fnum);
    if ((vp->flags & 0xc0) == 0x40)
	printf("shared ");
    if ((vp->flags & 0xc0) == 0x80)
	printf("new shared ");
    if ((vp->flags & 0xc0) == 0xc0)
	printf("new global shared ");
    if ((vp->flags & 0x30) == 0)
	printf("variable ");
    else
	switch(vp->flags &0x30)
	{
	    case 0x10: printf("input parameter "); break;
	    case 0x20: printf("output parameter "); break;
	    case 0x30: printf("input-output parameter "); break;
	}
    printf("%s as %s",
	vp->name == NULL? vname(vp->tnum, vp->fnum, 0):vp->name,
	vtype(vp->type));
    if (vp->extent > 0)
	printf(" extent %d", vp->extent);
    if (vp->flags & 0x04 && vp->extent == 0)
	printf(" extent (unknown ?)");
    if ((vp->flags & 0x01) == 0x01)
	printf(" no-undo");
    if ((vp->flags & 0x08) == 0x08)
	printf(" case-sensitive");
    if (vp->ival != NULL)
	printf(" initial %s", vp->ival);
    printf(".\n");
}

int getfv_bynam(char *name)
{
    us i, c;

    i = vlist;
    c = 2;
    while (1)
    {
	i++;
	if(*(p + i) == '\0')
	{
	    if(*(p + i + 1) == '\0')
	    break;
	    c++;
	}
	if(*(p + i - 1) == '\0')
	    if (strcmp((char *) p + i, name) == 0)
		return(c);
	if (i > pend) 
	    return(-1);
    }
    return (-1);
}

struct fld *gvbynam(char *name)
{
    us i;
    for (i = 0; i < vmax; i++)
    {
	if(vnlist[i] != NULL)
	    if(strcmp(vnlist[i]->name, name) == 0)
		return(vnlist[i]);
	if(vulist[i] != NULL)
	    if(strcmp(vulist[i]->name, name) == 0)
		return(vulist[i]);
	if(vslist[i] != NULL)
	    if(strcmp(vslist[i]->name, name) == 0)
		return(vslist[i]);
    }
    return(NULL);
}

struct db *listdb(us a)
{
    struct db *dbp;

    if (a == 0)
	return(NULL);
    if (lflag)
	printf(" * Database %3d %32s\n",
	    gs(a+2),		/* db number */
	    p + a + 8		/* db name */
	    );
    dbp = malloc(sizeof(struct db));
    dbp->next = listdb(gs(a));
    dbp->dbnum = gs(a+2);
    dbp->file_head = NULL;
    strncpy(dbp->name, (char *) p + a + 8, NAMELEN);
    return(dbp);
}

void listsv(us a, char *prefix)
{
    struct fld *vp;
    if (a == 0)
	return;
    if (vdebug)
    {
	printf("def %sshared var %s as %s",
	    prefix, p + gs(a+2), vtype(gs(a+4)));
	if (gs(a+12) == 1) 
	    printf(" no-undo");
	if (gs(a+8) > 0)
	    printf(" extent %d", gs(a+8));
	printf(".\n");
    }
/*     if (gs(a+6) != 0) */
	fixv(gs(a+12),
	     gs(a+6),
	     (char *) p + gs(a+2),
	     gs(a+4),
	     0x80 | ((gs(a+8) == 0) ? 0x00 : 0x04) |
		 (prefix[4] == 'g' ? 0x40:0) |
		 (gs(a+12)?1:2),
	     gs(a+8),
	     0, "listsv");
    if (gs(a+6) == 0 && prefix[4] == 'g')
    {
	vp = gvbynam((char *) p + gs(a+2));
	if (vp != NULL)
	    vp->flags |= 0xc0;
    }
    listsv(gs(a), prefix);
}

void listparam(us a, char *prefix)
{
    if (a == 0)
	return;
    if (vdebug)
    {
	printf("def %s %s as %s",
	    prefix, vname(gs(a+6), gs(a+8), 0), vtype(gs(a+2)));
	if (gs(a+6) == 1) 
	    printf(" no-undo");
	printf(".\n");
    }
    /* FIXME: maybee none of this is necessary */
    fixv(gs(a+6),
	 gs(a+8),
	 NULL,
	 gs(a+2),
	 gs(a+6) | ((prefix[0] == 'i') ? 0x10 : 0x20), /* FIXME: not sure */
	 0, /* FIXME: never looked */
	 0, "parameter"); 
    listparam(gs(a), prefix);
}

us cntv(us a)
{
    us i, cnt;
    i = a;
    cnt = 2;
    while (1)
    {
	i++;
	if(*(p + i) == '\0')
	{
	    if(*(p + i + 1) == '\0')
	        break;
	    cnt++;
	}
    }
    return(cnt);
}

struct fld *getfld_byrid(us db, int recid)
{
    struct db *dbp;
    struct file *filep;
    struct fld *fldp;

    dbp = getdb_bynum(db);
    filep = dbp->file_head;
	while (filep != NULL)
	{
	    fldp = filep->fld_head;
		while (fldp != NULL)
		{
		    if(fldp->recid == recid)
			return(fldp);
		    fldp = fldp->next;
		}
	    filep = filep->next;
	}
	return(NULL);
}

struct db *getdb_bynum(us dbnum)
{
    struct db *dbp;

    dbp = dbhead;
    while (dbp != NULL)
    {
       if (dbp->dbnum == dbnum)
	   return(dbp);
       dbp = dbp->next;
    }
    return(NULL);
}

void fixival()
{
    fiv(vulist);
    fiv(vnlist);
}

void fiv(struct fld **list)
{
    int i;
    us e, sz;
    struct fld *vp;
    if (vdebug)
	printf("fixing ivalues\n");
    i = 2;
    while (list[i] != NULL && list[i]->ivala != 0)
    {
	vp = list[i];
	if (vdebug)
	    printf("fix ivalue for %30s %04x %02x\n", 
		vname(vp->tnum, vp->fnum, 0), vp->ivala, gb(vp->ivala));

	sz = gb(vp->ivala);
	switch(sz)
	{
	    case 0x00:  /* zero length -- note ? is default for dates */
			if (vp->type == T_DAT)
			    vp->ival = "05/02/1950";
			else
			    if (vp->type == T_RID)
				vp->ival = "0";
			    else
				vp->ival = NULL;
			break;
			
	    case 0xe6:  /* longer than 229 bytes */
			vp->ival = iv(vp->ivala+3, gs(vp->ivala+1), vp->type);
			break;

	    case 0xf9:  /* today */
			vp->type = T_DAT;
			vp->ival = "today";
			break;

	    case 0xfa:  /* array */
			vp->flags |= 4;
		        vp->ival = aiv(vp->ivala + 3, 
				       gs(vp->ivala + 1), vp->type);
		        e = eaiv(vp->ivala + 3, gs(vp->ivala + 1));
		        if (e > vp->extent)
			    vp->extent = e;
			break;

	    case 0xfd:  /* unknown value -- note ? is default for dates */
			if (vp->type == T_DAT || vp->type == T_RID)
			    vp->ival = NULL;
			else
			    vp->ival = "?";
			break;

	    default:    /* length in sz */
			if (sz > 0xe5)
			    faterror("New type in initial value list %02x", sz);
			vp->ival = iv(vp->ivala + 1, sz, vp->type);
	}
	if (vdebug)
	    printf("ival is %s\n", vp->ival);
	i++;
    }
}

char *aiv(us a, us l, us dtype)
{
    us ptr, sz;
    char *fv, *v, *r;
    int first = 1, same = 1;
    ptr = a;
    while (ptr < a + l && gb(ptr) != 0xff)
    {
	sz = gb(ptr);
	switch(sz)
	{
	    case 0x00:  /* zero length -- note ? is default for dates */
			if (dtype == T_DAT)
			    v = "05/02/1950";
			else
			    if (dtype == T_RID)
				v = "0";
			    else
				v = NULL;
			ptr += 1;
			break;
			
	    case 0xe6:  /* longer than 229 bytes */
			v = iv(ptr+3, gs(ptr+1), dtype);
			ptr += 3 + gs(ptr + 1);
			break;

	    case 0xe7:
		      printf("/* Ivalue %02x junk discarded */\n", sz);
		      ptr += 4 + gb(ptr+2);
		      break;

	    case 0xf9:  /* today */
/* It would be nice to use this information but a but difficult */
/* 			vp->type = T_DAT; */
			v = "today";
			ptr += 1;
			break;

	    case 0xfa:  /* array */
			faterror("Aray within array @ %04x", ptr);

	    case 0xfd:  /* unknown value */
			v = "?";
			ptr += 1;
			break;

	    default:    /* length in sz */
			if (sz > 0xe5)
			    faterror("New type in initial value list %02x", sz);
			v = iv(ptr + 1, sz, dtype);
			ptr += 1 + sz;
	}
	if (sz == 0xe7)
	    continue;
	if (first)
	{
	    r = fv = v;
	    first = 0;
	}
	else
	{
	    r = mpf("%s, %s", r, v);
	    if (strcmp(fv, v) != 0)
		same = 0;
	}
    }
    if (same && (dtype == T_DAT || dtype == T_RID) && strncmp("?", fv, 2) == 0)
	 return(NULL);
    if (same)
	 return(fv);
    return(mpf("[%s]", r));
}

us eaiv(us a, us l)
{
    us ptr, sz, i = 0;
    ptr = a;
    while (ptr < a + l && gb(ptr) != 0xff)
    {
	sz = gb(ptr);
	switch(sz)
	{
	    case 0x00:  /* zero length */
			ptr += 1;
			break;
			
	    case 0xe6:  /* longer than 229 bytes */
			ptr += 3 + gs(ptr + 1);
			break;

	   case 0xe7:
		      ptr += 4 + gb(ptr+2);
		      break;

	    case 0xf9:  /* today */
/* It would be nice to use this information but a but difficult */
			ptr += 1;
			break;

	    case 0xfa:  /* array */
			faterror("Aray within array @ %04x", ptr);

	    case 0xfd:  /* unknown value */
			ptr += 1;
			break;

	    default:    /* length in sz */
			if (sz > 0xe5)
			    faterror("New type in initial value list %02x", sz);
			ptr += 1 + sz;
	}
	if (sz != 0xe7)
	    i++;
    }
    return(i);
}

char *iv(us a, us l, us dtype)
{
     if (vdebug)
	 printf("running iv a=%04x l=%d dtype=%d\n", a, l, dtype);
     switch (dtype)
     {
	 case 0:     return(mpf("(unknown type data at %04x, len %04x)", a, l));
	 case T_CHA: return(character(l, a));
 	 case T_DAT: return(idate(l, a));
 	 case T_LOG: return(ilogical(l, a));
	 case T_INT: return(iinteger(l, a));
	 case T_RID: return(iinteger(l, a));
	 case T_DEC: return(idecimal(l, a));
	 case T_RAW: return("(?? raw - data ??)");
	 default:    return(mpf("(unimplemented type %d data at %04x, len %04x)", a, l));
    }
}

void fillgaps()
{
    us i, j, k, t, f, cnt;
    for (i = 2; i < (us)(vmax - 1); i++)
	if(vflist[i] != NULL)
	{
	    if (cnt > 0 && 
		t == vflist[i]->tnum &&
		cnt == vflist[i]->fnum - f - 1)
		for (j = f + 1; j < vflist[i]->fnum; j++)
		{
		    if (t == 1)
			vflist[++k] = vnlist[j];
		    if (t == 0)
			vflist[++k] = vulist[j];
		    if (t > 1)
		       faterror("bad fillgaps");
		    fixv(t, j, getfvnam(k), 0, 0, 0, 0, "fillgaps");
		}
	    t = vflist[i]->tnum;
	    f = vflist[i]->fnum;
	    cnt = 0;
	    k = i;
	}
	else
	    cnt++;
}
