/*  load.c -- load data files
    Copyright (C) 1993  Grant Philip Maizels

    $Header: /usr/src/dp/RCS/load.c,v 0.6 1995/03/31 10:05:48 gpm Exp $

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

#include "dp.h"


void ldidf()
{
    struct db *dbp;
    struct file *filep;
    struct fld *fldp;
    struct idx *idxp;
    struct idf *idfp, *idft;
    char *f, fname[130], line[256], 
	 file[NAMELEN], index[NAMELEN], field[NAMELEN];
    int seq_num;
    FILE *fp;

    dbp = dbhead;
    while (dbp != NULL)
    {
        if (strcmp(dbp->name, " ") == 0)
	{
	    dbp = dbp->next;
	    continue;
	}
        sprintf(fname, "%s.idf", dbp->name);
	if ((f = fndpth(propath, fname)) == NULL)
	    faterror("\n/***** Can't find %s ****/\n", fname);
	if ((fp = fopen(f, "r")) != NULL)
        {
	    while(fgets(line, 255, fp) != NULL)
	    {
	        sscanf(line, "%s %s %s %d", file, index, field, &seq_num);
	        filep = dbp->file_head;
	        while (filep != NULL)
	        {
	            if (strncmp(file, filep->db_tname, NAMELEN) == 0)
		    {
			idxp = filep->idx_head;
			while (idxp != NULL)
			{
			    if (strncmp(index, idxp->name, NAMELEN) == 0)
				break;
			    idxp = idxp->next;
			}
			if (idxp == NULL) 
			    break;
			fldp = filep->fld_head;
			while (fldp != NULL)
			{
			    if (strncmp(field, fldp->name, NAMELEN) == 0)
				break;
			    fldp = fldp->next;
			}
			if (fldp == NULL) 
			    break;
			dbpf('l', " * Db %16s File %16s Idx %16s IF %s %3d\n",
				dbp->name, file, index, field, seq_num);
			idft = idxp->idf_head;
			idxp->field_cnt++;
			idfp = malloc(sizeof(struct idf));
			idfp->next = NULL;
			strncpy(idfp->name, field, NAMELEN);
			idfp->idx_seq = seq_num;
			idxp->file = filep;
			if (idft == NULL)
			    idxp->idf_head = idfp;
			else
			{
			    while(idft->next != NULL)
				idft = idft->next;
			    idft->next =idfp;
			}
		    }
		    filep = filep->next;
	        }
	   }
	   fclose(fp);
	}
	else
	    faterror(" * %s: not found\n", fname);
        dbp = dbp->next;
    }
}

void ldidx()
{
    struct db *dbp;
    struct file *filep;
    struct idx *idxp, *idxt;
    char *f, fname[130], line[256], file[NAMELEN], index[NAMELEN];
    int index_num;
    FILE *fp;

    dbp = dbhead;
    while (dbp != NULL)
    {
        if (strcmp(dbp->name, " ") == 0)
	{
	    dbp = dbp->next;
	    continue;
	}
        sprintf(fname, "%s.idx", dbp->name);
	if ((f = fndpth(propath, fname)) == NULL)
	    faterror("\n/***** Can't find %s ****/\n", fname);
	if ((fp = fopen(f, "r")) != NULL)
        {
	    while(fgets(line, 255, fp) != NULL)
	    {
	        sscanf(line, "%s %s %d", file, index, &index_num);
	        filep = dbp->file_head;
	        while (filep != NULL)
	        {
	            if (strncmp(file, filep->db_tname, NAMELEN) == 0)
		    {
			dbpf('l', " * Db %16s File %16s Index %03d %16s\n",
				dbp->name, file, index_num, index);
			idxt = filep->idx_head;
			idxp = malloc(sizeof(struct idx));
			idxp->next = NULL;
			strncpy(idxp->name, index, NAMELEN);
			idxp->idx_num = index_num;
			idxp->file = filep;
			idxp->idf_head = NULL;
			if (idxt == NULL)
			    filep->idx_head = idxp;
			else
			{
			    while(idxt->next != NULL)
				idxt = idxt->next;
			    idxt->next =idxp;
			}
		    }
		    filep = filep->next;
	        }
	   }
	   fclose(fp);
	}
	else
	    faterror(" * %s: not found\n", fname);
        dbp = dbp->next;
    }
}

void ldfld()
{
    struct db *dbp;
    struct file *filep;
    struct fld *fldp, *fldt;
    char *f, fname[130], line[256], file[NAMELEN], field[NAMELEN];
    int rpos, recid;
    FILE *fp;

    dbp = dbhead;
    while (dbp != NULL)
    {
        if (strcmp(dbp->name, " ") == 0)
	{
	    dbp = dbp->next;
	    continue;
	}
        sprintf(fname, "%s.fld", dbp->name);
	if ((f = fndpth(propath, fname)) == NULL)
	    faterror("\n/***** Can't find %s ****/\n", fname);
	if ((fp = fopen(f, "r")) != NULL)
        {
	    while(fgets(line, 255, fp) != NULL)
	    {
	        sscanf(line, "%s %s %d %d", file, field, &rpos, &recid);
	        filep = dbp->file_head;
	        while (filep != NULL)
	        {
	            if (strncmp(file, filep->db_tname, NAMELEN) == 0)
		    {
		        dbpf('l', " * Db %12s File %16s Field %03d %16s %03d\n",
				dbp->name, file, rpos, field, recid);
			fldt = filep->fld_head;
			fldp = malloc(sizeof(struct fld));
			fldp->next = NULL;
/* 			strncpy(fldp->name, field, NAMELEN); */
			fldp->name = mpf("%s", field);
			fldp->fnum = rpos;
			fldp->recid = recid;
			fldp->tnum = filep->tnum;
			if (fldt == NULL)
			    filep->fld_head = fldp;
			else
			{
			    while(fldt->next != NULL)
				fldt = fldt->next;
			    fldt->next =fldp;
			}
		    }
		    filep = filep->next;
	        }
	        filep = dbhead->file_head;
	        while (filep != NULL)
	        {
	            if (strncmp(file, filep->db_tname, NAMELEN) == 0 &&
			filep->db_filnum != 0 &&
			dbp->dbnum == filep->db_dbnum)
		    {
		        dbpf('l', " * Db %12s File %16s Field %03d %16s %03d\n",
				dbp->name, file, rpos, field, recid);
			fldt = filep->fld_head;
			fldp = malloc(sizeof(struct fld));
			fldp->next = NULL;
			strncpy(fldp->name, field, NAMELEN);
			fldp->fnum = rpos;
			fldp->recid = recid;
			fldp->tnum = filep->tnum;
			if (fldt == NULL)
			    filep->fld_head = fldp;
			else
			{
			    while(fldt->next != NULL)
				fldt = fldt->next;
			    fldt->next =fldp;
			}
		    }
		    filep = filep->next;
	        }
	   }
	   fclose(fp);
	}
	else
	    faterror(" * %s: not found\n", fname);
        dbp = dbp->next;
    }
}

void ldfil()
{
    struct db *dbp;
    struct file *filep;
    char *f, fname[130], line[256], file[NAMELEN];
    int file_num;
    FILE *fp;
    dbp = dbhead;
    while (dbp != NULL)
    {
        if (strcmp(dbp->name, " ") == 0)
	{
	    dbp = dbp->next;
	    continue;
	}
        sprintf(fname, "%s.fil", dbp->name);
	if ((f = fndpth(propath, fname)) == NULL)
	    faterror("\n/***** Can't find %s ****/\n", fname);
	if ((fp = fopen(f, "r")) != NULL)
        {
	    while(fgets(line, 255, fp) != NULL)
	    {
	        sscanf(line, "%s %d", file, &file_num);
	        filep = dbp->file_head;
	        while (filep != NULL)
	        {
	            if (strncmp(file, filep->db_tname, NAMELEN) == 0)
		    {
		        dbpf('l', " * Db %12s File %16s num %03d\n",
				dbp->name, file, file_num);
			    /* do nothing for now */
		    }
	            if (file_num == filep->db_filnum)
		    {
/* 			strncpy(filep->db_tname, file, NAMELEN); */
/* 		        dbpf('l', " * Db %12s File %16s num %03d -- workfile\n", */
/* 				dbp->name, file, file_num); */
		    }
		    filep = filep->next;
	        }
	   }
	   fclose(fp);
	}
	else
	    faterror(" * %s: not found\n", fname);
        dbp = dbp->next;
    }
}

void ldfilwf()
{
    struct db *dbp;
    struct file *filep;
    char *f, fname[130], line[256], file[NAMELEN];
    int file_num;
    FILE *fp;
    dbp = dbhead;
    while (dbp != NULL)
    {
        if (strcmp(dbp->name, " ") == 0)
	{
	    dbp = dbp->next;
	    continue;
	}
        sprintf(fname, "%s.fil", dbp->name);
	if ((f = fndpth(propath, fname)) == NULL)
	    faterror("\n/***** Can't find %s ****/\n", fname);
	if ((fp = fopen(f, "r")) != NULL)
        {
	    while(fgets(line, 255, fp) != NULL)
	    {
	        sscanf(line, "%s %d", file, &file_num);
	        filep = dbhead->file_head;
	        while (filep != NULL)
	        {
	            if (dbp->dbnum == filep->db_dbnum && 
			file_num == filep->db_filnum)
		    {
			strncpy(filep->db_tname, file, NAMELEN);
		        dbpf('l', " * Db %12s File %16s num %03d -- workfile\n",
				dbhead->name, file, file_num);
		    }
		    filep = filep->next;
	        }
	   }
	   fclose(fp);
	}
	else
	    faterror(" * %s: not found\n", fname);
        dbp = dbp->next;
    }
}

void ldkey()
{
    FILE *fp;
    char line[256], *f;
    long i;
    char lbl[18];

    if ((f = fndpth(propath, "key.lbl")) == NULL)
	if ((f = fndpth(dlc, "key.lbl")) == NULL)
	    faterror("\n/***** Can't find key.lbl ****/\n");
    if ((fp = fopen(f, "r")) != NULL)
    {
        while(fgets(line, 255, fp) != NULL)
        {
	    sscanf(line, "%ld %s", &i, lbl);
	    lbl[strlen(lbl) - 1] = '\0';
	    if (i < 1024)
		strncpy(keylbl[i], lbl + 1, 16);
	    else
		printf("\n/***** Very big key number %s %ld ****/\n", lbl, i);
	}
    }
    else
	faterror("\n/***** Can't open key.lbl ****/\n");
    fclose(fp);
}

void ldexpr()
{
    FILE *fp;
    char line[256], *n, *f;
    int  e, pcnt, prec;
    char fmt_b[8];

    for(e = 0; e < 256; e++)
	sprintf(exprs[e].txt, "(? expr %02x)", e);
    if ((f = fndpth(propath, "expr.dat")) == NULL)
	if ((f = fndpth(dlc, "expr.dat")) == NULL)
	    faterror("\n/***** Can't find expr.dat ****/\n");
    if ((fp = fopen(f, "r")) != NULL)
    {
        while(fgets(line, 255, fp) != NULL)
        {
	    if (line[0] == '#')
		continue;
	    sscanf(line, "%x %d %d %s", &e, &pcnt, &prec, fmt_b);
	    n = strchr(line, '\"');
	    strncpy(exprs[e].txt, n + 1, 16);
	    strncpy(exprs[e].fmt, fmt_b, 8);
	    exprs[e].txt[15] = '\0';
	    if (exprs[e].txt[strlen(exprs[e].txt) - 1] =='\n')
		exprs[e].txt[strlen(exprs[e].txt) - 1] = '\0';
	    if (exprs[e].txt[strlen(exprs[e].txt) - 1] =='\"')
		exprs[e].txt[strlen(exprs[e].txt) - 1] = '\0';
	    exprs[e].pcount = pcnt;
	    exprs[e].preced = prec;
	    fflush(stdout);
	}
    }
    else
	faterror("\n/***** Can't open expr.dat ****/\n");
    fclose(fp);
    for(e = 0; e < 256; e++)
	 if (exprs[e].txt[0] != '\0')
	    dbpf('l', "expr %02x %d %d %s <%s>\n", e,
		exprs[e].pcount, exprs[e].preced,
		exprs[e].fmt, exprs[e].txt);
}
