/*  names.c 
    Copyright (C) 1993  Grant Philip Maizels

    $Header: /usr/src/dp/RCS/names.c,v 0.6 1995/03/31 10:05:49 gpm Exp $

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

#include "dp.h"

char *fname(us f)
{
    char  *fp, *frame;
    frame = malloc(80);
    if (frame == NULL)
	faterror("No memory for frame name");
    sprintf(frame, "frame%03d-f", f);
    fp = frame;
    if (f < 1024)	/* who has more than 1024 frames */
	if( gs(gs(gs(FRMLST) + (12 * f) + 6) + 50) != 0)
		fp = (char *) (p + gs(gs(gs(FRMLST) + (12 * f) + 6) + 50));
    return(fp);
}

char *fvi(us f, us n)
{
    return(mpf("%s[%s]", 
	fvname2(gs(gs(FRMLST) + (12 * f) + 6) + 52,
	    gs(gs(fvilist + (65535 - n) * 4 + 2) + 6), 0),
	expr(gs(fvilist + (65535 - n) * 4), 0)));
}

char *old_fvname(us f, us v)
{
    char  *fp, *frame;
    frame = malloc(80);
    if (frame == NULL)
	faterror("No memory for frame variable name");
    if (f < 1024)	/* who has more than 1024 frames */
    {
	if( gs(gs(gs(FRMLST) + (12 * f) + 6) + 50) != 0)
	{
	    fp = (char *) (p + gs(gs(gs(FRMLST) + (12 * f) + 6) + 50));
	    sprintf(frame, "%s->%d%s", fp, v, v>0x8000?fvi(f, v):"");
	}
	else
	    sprintf(frame, "frame%03d-f->%d%s", f, v, v>0x8000?fvi(f, v):"");
	fp = frame;
    }
    if(Vdebug)
    {
	printf("\n fvname(f=%04x, v=%04x) -> %s\n", f, v, fp);
	fflush(stdout);
    }
    return(fp);
}

char *sfvname(us f, us v) /* short frame variable name (no array index) */
{
    if(v > 0x8000)
	return(fvname2(gs(gs(FRMLST) + (12 * f) + 6) + 52,
	    gs(gs(fvilist + (65535 - v) * 4 + 2) + 6), 0));
    if(Vdebug)
	printf("\n fvname(f=%04x, v=%04x)\n", f, v);
    if (f > 1023)	/* who has more than 1024 frames */
	return(old_fvname(f, v));
    else
	return(fvname2(gs(gs(FRMLST) + (12 * f) + 6) + 52, v, 0));
}

char *fvname(us f, us v)
{
    if(v > 0x8000)
	return(fvi(f, v));
    if(Vdebug)
	printf("\n fvname(f=%04x, v=%04x)\n", f, v);
    if (f > 1023)	/* who has more than 1024 frames */
	return(old_fvname(f, v));
    else
	return(fvname2(gs(gs(FRMLST) + (12 * f) + 6) + 52, v, 1));
}

char* fvname2(us a, us v, int doarray)
{
    char buf1[80], buf2[4096], *ptr;
    if (a > pend)
    {
	printf("Access beyond end %04x\n", a);
	return(NULL);
    }
    if (gs(a+2) == 0 || gs(a+2) >= 0x2000)
	return(NULL);
    if ((gs(a) & 0x7f00) == 0x0000)
    {
 	if (v != 0) 
	    return(fvname2(a+gs(a+2), v - 1, doarray));
	sprintf(buf1, "%s",
	(gs(a+12) == 0xffff ? 
	    (char *) p + vlist - gl(a+12):
	    getfld_byrid((us)gb(a+16), gs(a+14))->name));
/* FIXME: i think this is wrong */
	if((gs(a + 16) & 0xff) != 0 && doarray)
	    sprintf(buf2, "[%d]", gs(a+16)&0xff); 
	else
	    buf2[0] = '\0';
	ptr = (char *) malloc(strlen(buf1) + strlen(buf2) + 4);
	if (ptr == NULL) 
	    faterror("No memory for var name");
	sprintf(ptr, "%s%s", buf1, buf2);
	return(ptr);
    }
    return(fvname2(a+gs(a+2), v, doarray));
}

char *getfvnam(us v)
{
    us i, c;

    i = vlist;
    c = 2;
    while (1)
    {
	i++;
	if(*(p + i) == '\0')
	{
	    if(*(p + i + 1) == '\0')
	    break;
	    c++;
	}
	if(*(p + i - 1) == '\0')
	    if (c == v)
		return((char *) p + i);
	if (i > pend) 
	    return(NULL);
    }
    return (NULL);
}

char *gettnm(us t, us a)
{
    if (a == 0)
	return(NULL);
    if (gs(a+2) == t)
	return((char *) p + gs(a + 10));
    return(gettnm(t, gs(a)));
}

struct fld *gvbynum(us tnum, us fnum)
{
   if (Vdebug)
       printf("gvbynum(tnum=%d, fnum=%d)\n", tnum, fnum); 
   if(tnum > gs(TCNT))
      printf("gvbynum: tnum %d, out of range\n", tnum);
   if(fnum > vmax)
      printf("gvbynum: fnum %d, out of range\n", fnum);
   if(tnum == 1 && fnum < vmax)
       return(vnlist[fnum]);
   if(tnum == 0 && fnum < vmax)
       return(vulist[fnum]);
   if(fnum == 0 && tnum < vmax)
       return(vslist[tnum]);
   printf("gvbynum: illegal variable %d %d (vmax is %d)\n", tnum, fnum, vmax);
   return(NULL);
}

char *tname(us t)
{
    if (Vdebug)
	printf("tname(t=%04x);", t);
    return(gettnm(t, tlist));
}

char *fldname(us f, us t)
{
    struct db *dbp;
    struct file *filep;
    struct fld *fldp;

    if (Vdebug)
	printf("fldname(%04x, %04x);\n", f, t);
    dbp = dbhead;
    while (dbp != NULL)
    {
       if (dbp->dbnum == tdb(t))
	   break;
       dbp = dbp->next;
    }
    filep = dbp->file_head;
    while (filep != NULL)
    {
       if (strncmp(filep->name, tname(t), NAMELEN) == 0)
	   break;
       filep = filep->next;
    }
    fldp = filep->fld_head;
    while (fldp != NULL)
    {
       if (fldp->fnum == f)
	   break;
       fldp = fldp->next;
    }
    if (db_dot && file_dot)
	return(mpf("%s.%s.%s", dbp->name, filep->name, fldp->name));
    if (file_dot)
	return(mpf("%s.%s", filep->name, fldp->name));
    else
	return(fldp->name);
}

char *sname(us s)
{
    char *ptr;
    if (s == 0x32)
	return("input");
    if (s == 0x33)
	return("output");
    if (s >= gs(STRCNT))
    {
	ptr = (char *) malloc(16);
	if (ptr == NULL) 
	    faterror("No memory for variable name");
	sprintf(ptr, "Undefined %04x", s);
	return(ptr);
    }
    return((char *) p + gs(STRLIST) + 16 * s);
}

char *vname(us t, us v, us s)
{
    char *name = NULL;
    struct fld *n;

    dbpf('V', "vname(t=%04x, v=%04x, s=%04x);", v, t, s);
    if (s == 1)
	return("terminal");
    if (s == 2)
	return("propath");
    if (t > 1 && v > 0)
	return(fldname(v, t));
    n = gvbynum(t, v);
    if (n != (struct fld *)NULL) 
        name = n->name;
    if (name != NULL)
	return(name);
    dbpf('V', "name generated\n");
    return(mpf("var-%d-%d", t, v));
}
