.\"    r-code.ms -- description of Progress r-code internal format
.\"    
.\"    $Header: /usr/src/dp/RCS/r-code.ms,v 0.6 1995/03/31 10:05:50 gpm Exp $
.\"    
.\"    The contents of this file are the results of experimental work
.\"    Under no circumstances should the be considered to be a true
.\"    and accurate representation of the internal format of r-code.
.\"    This information has be determined without the assistance 
.\"    of Progress Software Corporation.
.\"
.\"    Copyright (C) 1993  Grant Philip Maizels
.\"
.\"    This program is free software; you can redistribute it and/or modify
.\"    it under the terms of the GNU General Public License as published by
.\"    the Free Software Foundation; either version 2 of the License, or
.\"    (at your option) any later version.
.\"
.\"    This program is distributed in the hope that it will be useful,
.\"    but WITHOUT ANY WARRANTY; without even the implied warranty of
.\"    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
.\"    GNU General Public License for more details.
.\"
.\"    You should have received a copy of the GNU General Public License
.\"    along with this program; if not, write to the Free Software
.\"    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */
.\"
.        \" DL - DLC macro
.de DL
.ie \\n(DL P\s-1ROGRESS\s0\\$1
.el \{\
\s-1PROGRESS\s0\\$1\(dg
.FS
\(dg \s-1PROGRESS\s0 is a registred trademark of Progress Software Corporation.
.FE
.nr DL 1
.\}
..
.de QS
.br
.vs 8
\fC\s-3
.nf
..
.de QE
.fi
\s+3\fR
.vs 12
..
.TL
The
.DL
R-Code file format
.AU
Grant P. Maizels
.AB NOTE
This document describes the binary format of Compiled
code genereated by the
.DL
Version 6 compiler.
.br
This document is still being written.
.br
The information described here has been determined experimentally and
is provided on an as is basis.
.AE
.PS 9
.2C
.NH
Introduction
.PP
.DL
R-code 
.PP
Most of the r-code structures are based what I will define as r-code pointers,
r-code offests, and r-code counts;
.QS
     typedef unsigned short rp;
     typedef unsigned short ro;
     typedef unsigned short rc;
     typedef *e_expr  expr;
     typedef *r_stmnt stmnt;
.QE
.NH
Primary Header
.PP
The first r-code structure is a header containing magic numbers, compilation
date and the size of the remainder of the r-code. I have no idea what the
rest of the numbers are but they seem to always be zero except data1.
.QS
   struct r_phdr {
      long magic;
      long comp_date;
      long pad3
      long data1
      long pad5
      long pad6
      long pad7
      long pad8
      long pad9
      long pad10
      long pad11
      long pad13
      long pad14
      long pad15
      long pad16
      long size
    }
.QE
.NH
Procedure Header
.PP
The procedure header follows the primary header and on version 6 is 52 bytes
long
.QS
    struct r_proc {
       rp      tlst;
       rc      tcnt;
       rp      frmlst;
       rc      frmcnt;  /* including
                           0xffffffff entry */
       rp      ngsvlist;
       rc      bgcnt;
       rp      bglst;
       rp      svlist;
       r_blk   *hdrptr;
       rp      strlist;
       rc      strcnt;
       rp      vlist;
       rp      sbuflist;
       rp      wfcnt;
       rp      sframlist;
*****  rp      h001e;
       rp      fvilist;
       rc      dbcnt;
       rp      dblst;
*****  rp      H0026;
*****  rp      H0028;
       rp      ilist;   /* see Initial Values */
       rp      release;
       rp      oparam;
       rp      iparam;
       pad     pad;
    }
.QE
.I wfcnt
is the number of workfiles that are not shared or are new shared.
.NH
The Block Structure
.PP
.QS
   struct r_blk {
      blknum blknum;
      rc     blklev;
      rp     init;
      recst  *recstuff;
      rp     control;
      rp     stmnts;
      rp     validate;
      rp     release1;
      rp     o_endkey;
      rp     o_error;
      rp     release2;
****  rp     ????;   /* might be some kind of
                        frame count */
      rp     tranflg;
      rc     itflg;
      char   systran;
      char   istran;
****  rc     ?; /* this is effected by frames */
      rc     normally 1;
      rc     normally 1;
      rc     normally 0;
      rc     normally 0;
      rc     normally 0;
      rc     normally 0;
      ...
      rp     count_expr;
   }

   struct recst {
      stmnt  s1;
      stmnt  s2;
      stmnt  s3;
      stmnt  s4;
   }
.QE
.NH
Statements
.PP
Some general text about statement headers and linked lists goes here.
The 
.I r_stmnt
structure is immedatly followed by the structure seleced by
.I stmnt_type.
.QS
     struct r_stmnt {
         r_stmnt *next;
         rc      stmnt_type;
     }
.QE
.NH 2
Blocks
.PP
The
.I r_blkstmnt
structure simply points to a
.I r_blk
structure.
.QS
   #define ST_BLK                0x64

   struct r_blkstmnt {
      r_blk blk;
      pad   pad1;
   }
.QE
.NH 2
Flow Control with If
.PP
The if statment provides the address off three statement lists, the
expression evaluation, the true path, and the false path.
.QS
   #define ST_IF                 0x64

   struct r_if {
      slist condition;
      slist true;
      slist false;
      pad   pad1;
   };
.QE
.PP
The \fIcondition\fR statement list always contains a single if evaluation
statement (ST_IFEVAL). Similar evaluating statement lists are used
in compile, run, etc (ST_EVAL) and finds using recids (ST_RIDEVAL).
.QS
   #define ST_EVAL               0x132
   #define ST_IFEVAL             0x133
   #define ST_RIDEVAL            0x1f8

   struct r_eval {
      expr expr;
      pad  pad1;
   }
.QE
.NH 2
Other Flow Control
.PP
The undo, leave, next, and return statements all have the same format.
.QS
   #define ST_UNDO               0x259

   struct r_if {
      blknum undoblk;
      blknum flowblk;
      rc     fc_type;
      pad    pad1;
   };

   #define FCT_LEAVE             0xe880
   #define FCT_RETRY             0xe865
   #define FCT_NEXT              0xe881
   #define FCT_LEAV2             0xf752
.QE
.PP
If the value of \fIundoblk\fR is not 0xffff then the statement is an undo
statement and \fIundoblk\fR is the block number of the block to be undone.
The value of fc_type contains the type of flow control to executed.  I have
no idea why such strange numbers are used. There are two values for leave,
and return is just a special case of leave where the block left is the
procedure block (\fIflowblk\fR is 0). The two one line programs
.QS
    leave.

and

    return.
.QE
.LP
will produce the same r-code.
.NH 2
Run
.PP
Palst and inpst always contain statements of type ST_EVAL while ouplst
always contains statements of type ST_ASS with deail lines always 0x2000.
Pacnt is a count of the items in palst.  The first statement in palist is
the program name of the procedure to be run, the remaining statements are
arguments.  Since the parameters are in two lists the actual origional
code can only be guessed, however sorting on the addresses helps with
this guessing.
.QS
   #define ST_RUN                0xfa

   struct r_run {
      stmnt palst;
      rc    pacnt;
      pad   pad3;
      rp    inplst;
      rp    ouplst;
      pad   pad6;
   };
.QE
.NH 2
The Call Statement
.PP
.QS
   #define ST_CALL               0xe2

   struct r_call {
      stmnt palst;
   }
.QE
.I Palst
in the call statement is similar to the run statement.
.NH 2
Simple Statments
.PP
The simplest statements have no parameters.  The statements include
\fIstop\fR, \fIquit\fR, \fIbell\fR, and \fIinput clear\fR. These statements
have the structure:
.QS
   #define ST_QUIT               0xc9
   #define ST_STOP               0xd3
   #define ST_INCLR              0xd7
   #define ST_BELL               0xd9

   struct r_smpl {
      pad pad1;
      pad pad2;
      pad pad3;
      pad pad4;
      pad pad5;
      pad pad6;
   };
.QE
.PP
I have no idea why it is necessary to waste so much space.
.NH 2
Assignment and Display Statements
.PP
The
\fIdisplay\fR, \fIprompt-for\fR, \fIassign\fR, \fIset\fR, \fIupdate\fR,
\fIchoose\fR, \fIcolor\fR, \fIexport\fR, \fIimport\fR,, \fIframe-value\fR,
\fIsubstring\fR, \fIoverlay\fR statements and simple assignment statements
all have the same statement type.
.QS
   #define ST_ASS                0x2c9

   struct r_ass {
      asslst  list;
      rc      frame;
      char    stream;
      char    ass_type;
      st_blk  edit_blk;
      rc      go_on;
      rc      pause;          /* not on dos */
   }
.QE
.PP
    /* assignment detail goes here */
.NH 2
Input and Output , and some _Trace Statements
.PP
.QS
   #define ST_IO                 0xcc

   struct r_io {
      asslst  values;
      rc      stream;
      slist   iolist;
      pad     pad1;           /* not in dos */
   }

   #define IOT_IN                1
   #define IOT_OUT               2
   #define IOT_INOUT             3

   struct r_iolist {
      pad     pad1;
      rc      type;
      trace   flags;     /* often 1 is io 0 is _trace */
      pad     pad4; /* \  one of these is */
      pad     pad5; /*  | missing in dos */
      pad     pad6; /* /  r-code. */
      rc      page_sz;
      rc      flags;
      pad     pad9;
      expr    map;
   }
.QE
.NH 2
Input Close and Output Close Statements
.PP
.QS
   #define ST_CLOSE              0x2c7

   struct r_close {
      flag   flg;    /* 1 = input
                      * 2 = output
                      * 3 = io */
      stream stream; /* 0xffff is default */
   }
.QE
.NH 2
The Put Statement
.PP
.QS
   #define ST_PUT                0x2c8

   struct r_putcur {
      p_put  *detail; 
      stream stream; /* 0xffff is default */
   }

   struct p_put {
       /* who knows -- see stmnts.c */
   }
.QE
.NH 2
The Put Screen Statement
.PP
.QS
   #define ST_PUTSCR             0xdf

   struct r_putscr {
      expr   text;
      expr   row;
      expr   col;
      expr   colour;
      flag   flg;    /* & 1 = 1 - attr-space
                        & 2 = 2 - no-attr-space */
   }
.QE
.NH 2
The Put Cursor Statement
.PP
.QS
   #define ST_PUTCUR             0xe3

   struct r_putcur {
      flag  off; /* if = 0 then put cursor off */
      int   row; /* if 0 then not specified */
      int   col; /* if 0 then not specified */
   }
.QE
.NH 2
The Message Statement
.PP
.QS
   #define ST_MESS               0xcf

   struct r_mess {
      stmnt  stmnts;
      r?     msgupdar;
      pad    pad3;
      r?     msgupdfmt;
      expr   colour;
   }
.QE
.NH 2
The Page Statement
.PP
.QS
   #define ST_PAGE               0xce

   struct r_page {
      pad    pad1;
      frame  frame; /* 0xffff is default */
   }
.QE
.NH 2
The Up and Down Statements
.PP
.QS
   #define ST_DOWN               0xd5
   #define ST_UP                 0xd6

   struct r_down {
      expr   lines;
      stream stream;
      frame  frame; /* 0xffff no frame */
   }
.QE
.NH 2
The Scroll Statement
.PP
.QS
   #define ST_SCROLL             0xd2

   struct r_scroll {
      pad    pad1;
      flag   fl; /* &1 = 1 from-current
                    &2 = 0 up
                    &2 = 2 down */
      frame  frame; /* 0xffff no frame */
   }
.QE
.NH 2
The Seek Statement
.PP
.QS
   #define ST_SEEK               0xf1

   struct r_status {
      expr   seek;
      stream stream; /* 0xffff = default */
      flag   fl; /* &1 1 = end
                    &2 2 = input
                    &4 4 = output */
   }
.QE
.NH 2
The Next Prompt Statement
.PP
.QS
   #define ST_NXTPRM             0xd8

   struct r_nxtprm {
      frmfld frmfld;
      frame  frame; /* 0xffff is default */
   }
.QE
.NH 2
The Record Statements
.QS
   #define ST_RELEAS             0x1f9
   #define ST_CREATE             0x1fa
   #define ST_DELETE             0x1fb
   #define ST_VALID              0x1fe

   struct r_rec {
       ri     table;
   }
.QE
.PP
.NH 2
The Find Statement
.PP
.QS
   #define ST_FORFND             0x01f5
   #define ST_FINDN              0x01f7
   #define ST_FIND               0x01fc
   #define ST_FINDR              0x01fd
   #define ST_FINDP              0x0202
   #define ST_FINDL              0x0203
   #define ST_FINDF              0x0204

   struct r_find {
      cmd   ni_where; /* non-indexed where phrase */
      rc    lck_flgs;
      rc    err_flgs;
      tbl   table;
      rc    ????;
      iwhdr i_where;  /* indexed where phrase */
      idx   index;
      pad   pad1;
   }

   #define FND_NL                0   /* no-lock */
   #define FND_SL                1   /* no-lock */
   #define FND_EL                2   /* no-lock */
   #define FND_NW                16  /* no-lock */

   struct r_iwhdr {
      iw     iw1;
      iw     iw2;
      ri     index;
      ri     cnt; /* ??? always 2? */
   };
   typedef struct r_iwhdr *iwhdr;

   struct r_iw {
      ri     index;  /* ??? */
      flg    cmptype; /* comparison type ??? */
      pad    zero1;
      pad    zero2;
      iwdet  iwdet[];
   }
   typedef struct r_iw *iw;

   struct r_iwdet {
       expr  condit;
   }
   typedef struct r_iwdet *iwdet;
.QE
.NH 2
Readkey
.PP
.QS
   #define ST_RDKEY              0xdb

   struct r_rdkey {
      rc     pause;
      stream stream;
      pad    pad3;
      pad    pad4;
      pad    pad5;
      pad    pad6;
   }
.QE
.NH 2
The Pause Statement
.PP
.QS
   #define ST_PAUSE              0xdd

   struct r_pause {
      expr time;
      flag no-message;  /* 1 = no-message */
      flag before-hide; /* 1 = before-hide */
      char *message;
   }
.QE
.NH 2
On
.PP
.QS
   #define ST_ON                 0xde

   struct r_on {
      pad  pad1
      rc   key;  /* as in values 
                    returned by lastkey */
      rc   onfunc;
   }

   /* values for onfunc */

   #define OF_bell               0x0007
   #define OF_backspace          0x0008
   #define OF_tab                0x0009
   #define OF_return             0x000d
   #define OF_delete_character   0x007f
   #define OF_go                 0x03e9
   #define OF_help               0x03ea
   #define OF_insert_mode        0x03eb
   #define OF_end_error          0x03ec
   #define OF_endkey             0x03ed
   #define OF_error              0x03ee
   #define OF_get                0x03ef
   #define OF_put                0x03f0
   #define OF_recall             0x03f1
   #define OF_clear              0x03f2
   #define OF_new_line           0x03f3
   #define OF_delete_line        0x03f4
   #define OF_break_line         0x03f5
   #define OF_append_line        0x03f6
   #define OF_block              0x03f7
   #define OF_find               0x03f8
   #define OF_page_up            0x03f9
   #define OF_page_down          0x03fa
   #define OF_back_tab           0x03fb
   #define OF_cursor_up          0x03fc
   #define OF_cursor_down        0x03fd
   #define OF_cursor_left        0x03fe
   #define OF_cursor_right       0x03ff
   #define OF_home               0x0400
   #define OF_stop               0x0401
   #define OF_stop_display       0x0404
   #define OF_resume_display     0x0405
   #define OF_right_end          0x0406
   #define OF_left_end           0x0407
   #define OF_choices            0x0408
   #define OF_settings           0x0409
   #define OF_reports            0x040a
   #define OF_goto               0x040b
   #define OF_scroll_left        0x040c
   #define OF_scroll_right       0x040d
   #define OF_insert_field       0x040e
   #define OF_insert_field_data  0x040f
   #define OF_insert_field_label 0x0410
   #define OF_delete_field       0x0411
   #define OF_insert_column      0x0412
   #define OF_delete_column      0x0413
   #define OF_pick               0x0414
   #define OF_pick_both          0x0415
   #define OF_cancel_pick        0x0416
   #define OF_move               0x0417
   #define OF_top_column         0x0418
   #define OF_bottom_column      0x0419
   #define OF_main_menu          0x041a
   #define OF_pick_area          0x041b
   #define OF_options            0x041c
.QE
.NH 2
Apply
.PP
.QS
   #define ST_APPLY              0xdc

   struct r_apply {
      expr key;
   }
.QE
.NH 2
Status
.PP
.QS
   #define ST_STAT               0xda

   struct r_status {
      expr text;
      flag i_d; /* 0 - default, 1 - input */
      flag off; /* 1 - off */
   }
.QE
.NH 2
Show-stats
.PP
.QS
   #define ST_SHST               0xf4

   struct r_shst {
      /* don't know */
   }
.QE
.NH 2
_trace
.PP
The _trace on and off statements.
.QS
   #define ST_TRCE               0xcb

   struct r_trace {
      flag on; /* 0 - off, 1 - on  ffff on _list */
   }
.QE
.NH
Expressions
.PP
...............
.NH 2
Constants
.PP
Character.
.PP
Date.
.PP
Logical.
.PP
Integer.
.PP
Decimal.
.NH 2
Expressions with no Arguments
.QS
    #define E_TODAY    0x2b
    #define E_SNUM     0x39
    #define E_RETRY    0x3a
    #define E_TIME     0x43
    #define E_OPSYS    0x44
    #define E_LASTKEY  0x45
    #define E_TERM     0x46
    #define E_MSGLNS   0x49
    #define E_SCRNLNS  0x4a
    #define E_FRM_FLD  0x4b
    #define E_FRM_FIL  0x4c
    #define E_FRM_VAL  0x4d
    #define E_GO_PNDG  0x51
    #define E_FRM_COL  0x59
    #define E_FRM_DWN  0x59
    #define E_FRM_LIN  0x59
    #define E_FRM_ROW  0x59
    #define E_PROGRESS 0x61
    #define E_FRM_DB   0x70
    #define E_FRM_INDX 0x71
    #define E_FRM_NAME 0x72
    #define E_IS_AT_SP 0x7b
    #define E_NUM_DBS  0x7d
    #define E_NUM_ALS  0x7f
    #define E_GATEWAYS 0x80
    #define E_PROPATH  0x89
    #define E_CONTROL  0x8d
    #define E_ETIME    0x95
.QS
    struct decimal {
        char   sign;    /* 1 positive
	                   0 negative */
        char   length;
        char   decimals;
        char   value[]
    }

    struct entered {
        rc     frame;
        rc     frame-field;
        rc     1;
        char   name[];
        ????   0x4001 or 0;
        ????   0xbec0 or element;
    }

.NH
Variables
.NH 2
Databases
.PP
A linked list of databases is pointed to by 
.I dblst
containing 
.I dbcnt
entries.
Each entry has the following format.
.QS
    struct db {
        dpp    next;
        dp     db;
        pad    pad4;
        pad    pad8;
        char   dbname[32];
        char   dbtype[32];
	char   junk[4]; /* ??? */
    }
.QE
The only known value for
.I dbtype
is \fC"\0PROGRESS\0"\fR
.PP
The first entry has database number 0 and has a null name.
.NH 2
Files, Buffers, Workfiles and Shared Variables
.PP
A linked list of files is pointed to by 
.I tlst
containing 
.I tcnt
entries.
Each entry has the following format.
.QS
     struct tbl {
        tblp  *next;
        tbl   tbl;
        char  *db_name; /* name of this
			   file in database */
        dbp   *db;
        dp    sharv;
        char  *name;
        rc    flags;      
        rp    ival;
        rc    ivcnt;
        rc    wf_l_tnum;        
        char  *wf_name;
*****   junk  who_knows; 
        long  time_stamp;
*****   funny funny; /* don't know what this
			is  medium sized nuber*/
        rc    fld_cnt;
        dbnum wf_l_dbnum;
        pad   pad1;
     }

     flags are ORed from
     0001 Shared (on wf implies new
		  unless 0020 is on)
     0002 Preselect (Buffer)
     0004 Workfile defined with like
     0008 Work file (Always seems to
		     be on when 0040 is on)
     0010 No-undo
     0020 Shared work file (not new)
     0040 Workfile
     0080 New (shared buffer)
     0100 Buffer/DB file
.QE
.NH 2
Shared Variables
.PP
A linked list of varaiables is pointed to by each of 
.I nsvlist
and
.I ngsvlist
in the procedure header.  The format of these lists is
.QS
     struct lst_nsv {
         rp      next;
         rp      name;
         dtype   type;
         fld     fld;  /* effective field */
         rc      extent;
         rp      next;
         rc      undo; /* 1 = no-undo */
     }
.QE
.PP
.I Nsvlist
points to a list of new shared vareiables,
.I ngsvlist
points to a list of new global shared variables.
.NH 2
Initial Values
.PP
The procedure header structure element ilist points to a list of linked
list of statments (all 0x1ff) which contian the initial values.
.QS
    struct r_ivalue {
        tbl    tnum;
        initel addr;
        rc     count;
        pad    pad1;
    }
.QE
.PP
.I Addr
points to a list of initial values each consisting of one byte followed
by the data.  If the initial byte is less than 0xe6 then it is the
size of the data.  The following escape codes have been decyphered:
.QS
    e6    Folling two bytes size of data 
          (greater than 0xe5)
    e7    looks like <e7 00 02 00 3d 00> purpose
          unknown first four bytes header the
	  third byte is the length of the
	  optional part.
    e8
    e9
    ea
    eb
    ec
    ed
    ef
    f0
    f1
    f2
    f3
    f4
    f5
    f6
    f7
    f8
    f9    today
    fa    Array
    fb
    fc
    fd    Unknown Value
    fe
    ff    End of Array data
.QE
Integers are stored as signed quantities in big endian order but with
variable number of bytes.  Dates are stored as integers with day 0 as
May 2nd, 1950 (the default for a date is the unknown value).  Logicals
are stored as integers with 0 as false and 1 as true.
.NH
Frames
.PP
The procedure header structure element frmlst points to an array of adjacent
structures which are the headers for each frame.
.QS
    struct frm_hdr {
        rc    blk_lev;
        rc    blk_num;
        ?     0;
        frame frame;
        ?     0;
        ?     0;
    }
.QE
.LP
.I Blk_lev
and
.I blk_num
are 0xffff for the last frame in the list.
.I Blk_lev
and
.I blk_num
are the block level and number of the block to which the frame is scoped, the
first entry for a particular block is that block's default frame.
.I Frame
points to the frame structure.
.QS
    struct frame {
        char  ?;
        char  lines;  /* lines in one itteration of frame */
                      /* only a char even if no of lines > 256 */
        char  labels; /* 0=side/no-labels, 
                         1=no-underline, 2=top-labels */
        char  down;   /* as in down 7 */
        char  row;
        char  column;
        rc    frm_dtl; /* offset to frame detail -- ?? */
        rc    ?;
        rc    sr;      /* scroll or retain data */
        char  flags1;
        char  flags2;
        char  ?;
        char  width;   
        rc    some_offset;
        rc    rowe;    /* offset to row expression */
        rc    cole;    /* offset to column expression */
        rc    downe;   /* offset to down expression */
        rc    titlec;  /* offset to title colour string */
        rc    title;   /* offset to title string */
        rc    tit_off; /* chars to left of const title */
        rc    titlece; /* offset to title colour expression */
        rc    titlee;  /* offset to title expression */
        rc    ?;
        rc    wfortit; /* width of area for expr title */
        rc    colour;  /* offset to display colour string */
        rc    coloure; /* offset to display colour expression */
        rc    ?;
        rc    pcolour;  /* offset to prompt colour string */
        rc    pcoloure; /* offset to prompt colour expression */
        rc    ?;
        rc    name;     /* frame name */
    }
.QE
.PP
The

/* information about frame detail goes here */
.QS
    struct frm_det {
        ri     fd_code;
        ri     fd_size;
    }

    #define FD_AUTORET 0x0001
    #define FD_??????? 0x0002
    #define FD_ATTRSPA 0x0004
    #define FD_NOLABEL 0x0008
    #define FD_??????? 0x0010
    #define FD_DEBLANK 0x0020
    #define FD_BLANK   0x0040
    #define FD_VAL_HLP 0x0100
    #define FD_END_SEC 0x0400
    #define FD_LABEL   0x0800
    #define FD_ULINE   0x0802

.QE
.NH
Break Groups
.PP
The procedure header varaiables
.I bgcnt
and 
.I bglst
are the count and head of break group linked list of structures of the format
.QS
     struct bg {
         rp     next;
         0001
         0001
         addr
         addr
         addr
         0001 or 0000
         0000
         0000
         0002
         rp     blk;
         pad    pad;
     }
.QE
.PP
Most of this makes no sense at present.
