/*  stmnts.c
    Copyright (C) 1993  Grant Philip Maizels

    $Header: /usr/src/dp/RCS/stmnts.c,v 0.6 1995/03/31 10:05:49 gpm Exp $

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

#include "dp.h"

us msgupdfmt;
us msgupdar;
int elseif;
int for_loop;
us macro_cnt;

void unchain(us start, int num)
/* num = 0 decompile list, num > 0 decompile numth element of list,
 * num = -1 decompile last element of list, num = -2 decompile all but last
 */
{
    us a, c, n, cnt = 0;
    char *sdumps;
    int sadbg, ssdbg, sedbg, sldbg;

    a = start;
    while(1)
    {
	cnt++;
	sdumps = hdumps;
	sadbg = adebug;
	ssdbg = sdebug;
	sedbg = edebug;
	sldbg = lflag;
	if (a == dumpon && Sdump)
	{
	    hdumps = "A";
	    hdump = 1;
	    printf("/* dump on %04x */\n", dumpon);
	    adebug = sdebug = edebug = lflag = 1;
	}
	c = gs(a + 2);
	n = gs(a);
	if (num == 0 || cnt == num || 
	   (num == -1 && gs(a) == 0)||(num == -2 && gs(a) != 0))
	    discmd(a, c);
	if (n == 0) break;
	a = n;
	hdumps = sdumps;
	adebug = sadbg;
	sdebug = ssdbg;
	edebug = sedbg;
	lflag = sldbg;
    }
}
/* vunchain is like unchain but outputs value( ) around the output */
void vunchain(us start)
{
    us a, c, n;

    a = start;
    while(1)
    {
	c = gs(a + 2);
	n = gs(a);
	propf(" value(");
	discmd(a, c);
	propf(")");
	if (n == 0) break;
	a = n;
    }
}

void discmd(us a, us c)
{
    dbpf('s', "\nstmnt: %04x %s--> %4x\n", a, indent(), c);
    switch(c)
    {
	case 0x00:	s_nop(a);          break; 
	case 0x64:	s_if(a);           break;
	case 0xc8:	s_block(a);        break;
	case 0xc9:	s_noargs(a);       break;
	case 0xca:	s_frame(a);        break;
	case 0xcb:	s__trace(a);       break;
	case 0xcc:	s_output(a);       break;
	case 0xcd:	s_frame(a);        break;
	case 0xce:	s_page(a);         break;
	case 0xcf:	s_message(a);      break;
	case 0xd0:	s_frame(a);        break;
	case 0xd1:	s_opsys(a);        break;
	case 0xd2:	s_scroll(a);       break;
	case 0xd3:	s_noargs(a);       break;
	case 0xd4:	s_frame(a);        break;
	case 0xd5:	s_down(a);         break;
	case 0xd6:	s_down(a);         break;
	case 0xd7:	s_noargs(a);       break;
	case 0xd8:	s_next_prompt(a);  break;
	case 0xd9:	s_noargs(a);       break;
	case 0xda:	s_status(a);       break;
	case 0xdb:	s_readkey(a);      break;
	case 0xdc:	s_apply(a);        break;
	case 0xdd:	s_pause(a);        break;
	case 0xde:	s_on(a);           break;
	case 0xdf:	s_put_screen(a);   break;
     	case 0xe2:	s_call(a);         break;
	case 0xe3:	s_put_cursor(a);   break;
	case 0xe5:	s_bad(a, "gen by create table"); break;
	case 0xe6:	s_bad(a, "gen by create table"); break;
	case 0xe7:	s_conn(a);         break;
	case 0xe8:	s_disc(a);         break;
	case 0xed:	s_sql2(a);         break;
	case 0xef:	s_notdone(a, "delete alias");            break;
	case 0xf0:	s_sql1(a);         break;
	case 0xf1:	s_seek(a);         break;
	case 0xf4:	s_notdone(a, "show-stats");		break;
	case 0xfa:	s_run(a);          break;
	case 0xfb:	s_comp(a);         break;
	case 0xfc:	s_comp(a);         break;
	case 0x12f:	s_notdone(a, "accumulate");		break;
	case 0x132:	s_eval(a);	   break;
	case 0x133:	s_eval(a);         break;
	case 0x134:	s_macro(a);        break;
	case 0x1f5:	s_find(a);         break;
	case 0x1f7:	s_find(a);         break;
	case 0x1f9:	s_rec(a);          break;
	case 0x1fa:	s_rec(a);          break;
	case 0x1fb:	s_rec(a);          break;
	case 0x1fc:	s_find(a);         break;
	case 0x1fd:	s_find(a);         break;
	case 0x1fe:	s_rec(a);          break;
	case 0x1ff:	s_ivalue(a);       break;
	case 0x202:	s_find(a);         break;
	case 0x203:	s_find(a);         break;
	case 0x204:	s_find(a);         break;
	case 0x259:	s_loopctl(a);      break;
	case 0x2c7:	s_output_close(a); break;
	case 0x2c8:	s_put(a);          break;
	case 0x2c9:	s_assign(a);       break;
	case 0x2cb:	s_bad(a, "gen by create table"); break;
	default:	s_bad(a, "unknown");
    }
}

void s_put(us a)
{
    propf("put"); 
    if (gs(a+6) != 0xffff)
	propf(" stream %s", sname(gs(a+6)));
    if ((gb(gs(a+4)+1)&2) == 2)
	propf(" control");
    else
	if (gs(gs(a+4)+4) == 0)
	    propf(" unformatted");
    disput(gs(a+4));
    propf(".\n");
}

void s_assign(us a)
{
    char *c2; 
    us ptr;

    switch (gb(a+9))
    {
	case 0x01: c2 = "display";       break;
	case 0x02: c2 = "prompt-for";    
		   if (gs(gs(a+4) + 4) == 0xb1de && gs(gs(a+4) + 2) == 0x02)
		       c2 = "set";
					 break;
	case 0x04: c2 = "assign";        
		   if (gs(gs(a+4) + 2) == 0x2000)
		       c2 = "output";
		   if (gs(gs(a+4) + 2) == 0x8000)
		       c2 = "import";
					 break;
	case 0x06: c2 = "set";           break;
	case 0x08: c2 = "color display"; 
		   if (gs(a+12) != 0)
		       c2 = "color prompt"; 
		   if (gs(gs(a+4) + 2) == 0x480 && gs(gs(a+4) + 10) == 0x80)
		       c2 = "underline";
					 break;
	case 0x17: c2 = "update";        break;
	case 0x20: c2 = "choose";        break;
	case 0x40: c2 = "frame-value";   break;
	case 0x81: c2 = "export";        break;
	default:   propf(" * unknown assignment type %02x\n", gb(a+9));
		   c2 = "";
		   break;
    }
    dbpf('a', "\n/* %02x %s */\n", gb(a+9), c2);
    if (adebug)
	d_assign(a);
	/* propath = and terminal = seem to have 0x4008 */
    if ((gs(gs(a+4) + 2) & 0xbfff)!= 0x08 || gs(gs(a+4) + 18) != 0x80)
    {
	propf("%s", c2);
	ind_lev++;
    }
    if (gb(a+8) != 0xff)
	propf(" stream %s", sname(gb(a+8)));
    if ((gs(gs(a+4) + 2) & 0xff ) == 0xc0) /* choose */
    {
	if (gs(gs(a+4) + 2) & 0x2000) /* no-error */
	    propf(" row");
	else
	    propf(" field");
	if ((gs(gs(a+4) + 2) & 0x4000) == 0) /* no-error */
	    propf(" no-error");
    }
    if (gs(a+10) != 0 && gb(a+9) == 0x20) /* choose keys */
	propf("     keys %s", expr(gs(a+10), 0));
    if (gs(a+10) != 0 && gb(a+9) == 0x08) /* color display */
	propf(" value(%s)", expr(gs(a+10), 0));
    if (gs(a+12) != 0 && gb(a+9) == 0x08) /* color prompt */
	propf(" value(%s)", expr(gs(a+12), 0));
    if (gs(a+4) != 0)
    {
	if ((gs(gs(a+4) + 2) & 0xbfff) != 0x08 || gs(gs(a+4) + 18) != 0x80)
	    disass(gs(a+4), (us) gb(a+9), gs(a+6), "\n");
	else
	    disass(gs(a+4), (us) gb(a+9), gs(a+6), "");
    }
    if ((gs(gs(a+4) + 2) & 0xbfff) != 0x08 || gs(gs(a+4) + 18) != 0x80)
	ind_lev--;
    if (gs(a+6) == 0xfffe)  /* message update, message set */
	propf(" format \"%s\"%s",
	    p + msgupdfmt, msgupdar & 0xff00?" auto-return":"");
    if ((gs(gs(a+4) + 2) & 0xff ) == 0xc0) /* choose */
	if ((gs(gs(a+4) + 2) & 0x0100)) 
	    propf(" auto-return");
    if (gs(a+12) != 0 && gb(a+9) != 0x08)
    {
	propf("\n    go-on (");
	ptr = gs(a+12);
	while(gs(ptr) > 0 & gs(ptr) < 0x8000)
	{
	     propf("%s ", keylbl[gs(ptr)]);
	     ptr += 2;
	}
	propf(")");
    }
    /* FIXME: what does dos do for pause value */
    if (gs(a+14) != 0 && ! dos) /* this is for choose */
	propf("\n    pause %s", expr(gs(a+14), 0));
    if (gs(a+6) != 0xffff && gs(a+6) != 0xfffe)
	propf("\n    with frame %s", fname(gs(a+6)));
    if (gs(a+10) != 0 && (gb(a+9) & 2) == 2)
    {
	ind_lev++;
	propf("\n");
	disblk(gs(a+10), 4);
	ind_lev--;
    }
    else
	propf(".\n");
    if (gs(a+6) == 0xfffe)  /* message update, message set */
	ind_lev--;
}

void s_noargs(us a)
{
    switch (gs(a+2))
    {
	case 0xd9:	propf("bell.\n");        break;
	case 0xd3:	propf("stop.\n");        break;
	case 0xc9:	propf("quit.\n");        break;
 	case 0xd7:	propf("input clear.\n"); break;
     }
}

void s__trace(us a)
{
    propf("_trace");
    if (gs(a+6) == 0) 
	propf(" off");
    if (gs(a+6) == 1) 
	propf(" on");
    if (gs(a+6) == 0xffff) 
	propf(" on _list");
    propf(".\n");
}

void s_page(us a)
{
    propf("page");
    if (gs(a+6) != 0xffff)
	propf(" stream %s", sname(gs(a+6)));
    propf(".\n");
}

void s_scroll(us a)
{
    propf("scroll");
    if ((gs(a+6) & 0x1) == 0x1) 
	propf(" from-current");
    if ((gs(a+6) & 0x2) == 0) 
	propf(" up");
    if ((gs(a+6) & 0x2) == 0x2) 
	propf(" down");
    if (gs(a+8) != 0xffff)
	propf(" with frame %s", fname(gs(a+8)));
    propf(".\n");
}

void s_next_prompt(us a)
{
    propf("next-prompt %s", fvname(gs(a+8), gs(a+6)));
    if (gs(a+8) != 0xffff)
	propf(" with frame %s", fname(gs(a+8)));
    propf(".\n");
}

void s_frame(us a)
{
    char *cs;
    switch(gs(a + 2))
    {
	case 0x00ca:
	case 0x00cd:  cs = "hide";    break;
	case 0x00d0:  cs = "view";    break;
	case 0x00d4:  cs = "clear";   break;
	default:      cs = "unknown";
    }
    propf("%s", cs);
    if (gs(a+2) != 0xd4 && gs(a+6) != 0xffff)
	propf(" stream %s", sname(gs(a+6)));
    if (gs(a+8) == 0xfffd)
	propf(" message");
    else if (gs(a+8) == 0xfffc)
	propf(" all");
    else if (gs(a+8) != 0x0000)
	propf(" frame %s", fname(gs(a+8)));
    if (gs(a+2) == 0xd4 && ((gs(a+6) & 1) == 1))
	propf(" all");
    if (gs(a+2) == 0xd4 && ((gs(a+6) & 2) == 2))
	propf(" no-pause");
    if (gs(a+2) == 0xcd)
	propf(" no-pause");
    /* should check to see if next instruction is a update with frame fffd
       if it is we should not display the period but instead set a flag
       so that the frame is not expanded on the update */
    propf(".\n");
}

void s_find(us a)
{
    char *cs;
    us i, cmd, niw, iw, lck_flg, err_flg, tbl, idx;
    int index_where = 0;

    cmd     = gs(a+2);
    niw     = gs(a+4);
    lck_flg = gs(a+6);
    err_flg = gs(a+8);
    tbl     = expr_tbl = gs(a+10);
    iw      = gs(a+14);
    idx     = expr_idx = gs(a+16);
    switch(cmd)
    {
	case 0x01f5:  cs = "for-loop";
		      for_loop = 2;
/* 		      return; */
						  break;
	case 0x01f7:  if(for_loop)
			  cs = "for each";
		      else
		          cs = "find next";
						  break;
	case 0x01fc:
	case 0x01fd:  if(for_loop)
			  cs = "for each";
		      else
		          cs = "find";
						  break;
	case 0x0202:  if(for_loop)
			  cs = "for each";
		      else
			  cs = "find prev";
						  break;
	case 0x0203:  if(for_loop)
			  cs = "for first";
		      else
			  cs = "find first";
						  break;
	case 0x0204:  if(for_loop)
			  cs = "for last";
		      else
			  cs = "find last";
						  break;
	default:      cs = "unknown";
    }
    propf("%s %s ", cs, tname(tbl));
    if (cmd == 0x1fd)
	propf("\n    where recid(%s) = %s",
		tname(tbl), recid);
    if (iw != 0)
    {
        /* This error check requires fixing FIX-ME */
	if(getidx(idx,tbl) != NULL)
	for(i = 0; i < getidx(idx,tbl)->field_cnt; i++)
	{
	    if(gs(gs(iw) + 8 + (2 * i)) == 0)
		break;
	    index_where = 1;
	    if (i == 0)
		propf("\n    where ");
	    else
		propf("      and ");
	    if(gs(iw) + 8 + (2 * i) != 0)
	    {
		dbpf('s', "\nFIND %04x %04x %04x\n", i, iw, gs(iw));
		propf("%s = ", 
		    getidf(i+1, idx, tbl)->name);
		propf("%s\n", expr(gs(gs(iw) + 8 + (2 * i)), 0));
	    }
	}
    }
    if (niw != 0)
    {
        if (index_where == 1)
	   propf(" and\n");
	else
	    propf("\n    where ");
        unchain(niw, 0);
    }
    if (idx < 1025)
	propf("\n    use-index %s", 
	    getidx(idx,tbl)->name);
    else
	if (idx != 0xfffe)
	    propf("\n    /* use-index index-%04x */", idx);
    if ((lck_flg & 0xf) == 0)
	propf("\n    no-lock");
    if ((lck_flg & 0xf) == 1)
	propf("\n    share-lock");
    if ((lck_flg & 0xf) == 2)
	propf("\n    exclusive-lock");
    if ((lck_flg & 0xf0) == 0x10)
	propf("\n    no-wait");
    if (err_flg == 0)
	propf("\n    no-error");
    propf(".\n");
    if (for_loop > 0 )
	for_loop--;
}

void s_rec(us a)
{
    char *cs;
    switch(gs(a + 2))
    {
	case 0x1f9:  cs = "release";   break;
	case 0x1fa:  cs = "create";    break;
	case 0x1fb:  cs = "delete";    break;
	case 0x1fe:  cs = "validate";  break;
	default:     cs = "unknown";
    }
    propf("%s %s.\n", cs, tname(gs(a+4)));
}

void s_eval(us a)
{
char * e;
    if (gs(gs(a) + 2) == 0x1fd)
	recid = expr(gs(a+4), 0);
    else
    {
	propf("%s", expr(gs(a+4), 0));
	if ((gs(a) != 0) && (gb(gs(a+4)) == 0x01))
	    propf(" ");
    }
}

void s_macro(us a)
{
    macro_cnt++;
    macros[macro_cnt] = expr(gs(a+4), 0);
}

void s_loopctl(us a)
{
    char * cs;

    switch(gs(a + 8))
    {
	case 0xe880:  cs = "leave";    break; /* also return */
	case 0xe865:  cs = "retry";    break;
	case 0xe881:  cs = "next";     break;
	case 0xf752:  cs = "leave";    break; /* what is this ?? */
	default:      cs = "unknown";
    }
    propf("");
    if (gs(a + 4) != 0xffff)
    {
	propf("undo");
	if (gs(a+4) != curr_blk)
	    propf(" LOOP-%03d", gs(a + 4));
	propf(", ");
    }
    if (gs(a+8) == 0xe880 && gs(a+6) == 0)
	propf("return");
    else
    {
	propf("%s", cs);
	if (gs(a+6) != curr_blk)
	    propf(" LOOP-%03d", gs(a + 6));
    }
    if (loop_ctl == 0)
	propf(".\n");
}

void s_status(us a)
{
    propf("status ");
    if (gs(a+6) == 0) 
	propf(" default");
    if (gs(a+6) == 1) 
	propf(" input");
    if (gs(a+8) == 1) 
	propf(" off");
    if (gs(a+4) != 0) 
	propf(" %s", expr(gs(a+4), 0));
    propf(".\n");
}

void s_message(us a)
{
    msgupdfmt = gs(a+10);
    msgupdar = gs(a+6);
    propf("message ");
    if (gs(a+12) != 0) 
	propf("color value(%s) ", expr(gs(a+12), 0));
    if (gs(a+4) != 0) 
	unchain(gs(a + 4), 0);

    /* check to see if the next statment is an update on the message frame
       eg message "Do you want to continue?" update ll-cont.
       produces two r-code statments is syntacticly one progress statement.
       The message frame 0xfffe is only used in this context so this test
       is valid. */
    if (gs(gs(a) + 2) == 0x2c9 && gs(gs(a)+6) == 0xfffe)
    {
	propf("\n");
	ind_lev++;
    }
    else
	propf(".\n");
}

void s_down(us a)
{
    if (gs(a+2) == 0xd5)
	propf("down");
    else
	propf("up");
    if (gs(a+6) != 0xffff)
	propf(" stream %s", sname(gs(a+6)));
    if (gs(a+4) != 0)
	propf(" %s", expr(gs(a+4), 0));
    if (gs(a+8) != 0xffff)
	propf(" with frame %s", fname(gs(a+8)));
    propf(".\n");
}

void s_on(us a)
{
    propf("on %s %s.\n", 
      (keylbl[gs(a+6)][0] == 0) ? "UNKNOWN-KEY?" : keylbl[gs(a+6)], 
      onfunc(gs(a+8)));
}

void s_put_screen(us a)
{
    propf("put screen ");
    if (gs(a+4) != 0) 	/* text */
	propf("%s", expr(gs(a+4), 0));
    if (gs(a+12) == 1) 
	propf(" attr-space");
    if (gs(a+12) == 2) 
	propf(" no-attr-space");
    if (gs(a+6) != 0) 
	propf(" row %s", expr(gs(a+6), 0));
    if (gs(a+8) != 0) 
	propf(" column %s", expr(gs(a+8), 0));
    if (gs(a+10) != 0) 
	propf(" color %s", expr(gs(a+10), 0));
    propf(".\n");
}

void s_put_cursor(us a)
{
    propf("put cursor ");
    if (gs(a+4) == 0) 
	propf(" off");
    if (gs(a+6) != 0) 
	propf(" row %s", expr(gs(a+6),0));
    if (gs(a+8) != 0) 
	propf(" column %s", expr(gs(a+8), 0));
    propf(".\n");
}

void s_readkey(us a)
{
    propf("readkey");
    if (gs(a+6) != 0xffff)
	propf(" stream %s", sname(gs(a+6)));
    if (gs(a+4) != 0) 
	propf(" pause %s", expr(gs(a+4), 0));
    propf(".\n");
}

void s_apply(us a)
{
    propf("apply");
    if (gs(a+4) != 0) 
	propf(" %s", expr(gs(a+4), 0));
    propf(".\n");
}

void s_seek(us a)
{
    propf("seek");
    if ((gs(a + 8) & 0x2) == 0x2)
	propf(" input");
    if ((gs(a + 8) & 0x4) == 0x4)
	propf(" output");
    if (gs(a+6) != 0xffff)
	propf(" stream %s", sname(gs(a+6)));
    propf(" to ");
    if ((gs(a + 8) & 0x1) == 0x1)
	propf("end");
    if (gs(a+4) != 0) 
	propf("%s", expr(gs(a+4), 0));
    propf(".\n");
}

void s_conn(us a)
{
   /* this does not provide a sensible way to decompile the following:
	   def var a as char.
	   connect value(a) -H 7.
       We need to rethink unchain.
       We have! using vunchain() instead
    */
    propf("connect ");
    if (gs(a+4) != 0) 
	vunchain(gs(a + 4));
    if (gs(a+8) == 1) 
        propf(" no-error");
    propf(".\n");
}

void s_disc(us a)
{
    propf("disconnect value(");
    if (gs(a+4) != 0) 
	propf(" %s", expr(gs(a+4), 0));
    if (gs(a+8) == 1) 
        propf(") no-error");
    propf(".\n");
}

void s_call(us a)
{
    propf("call ");
    if (gs(a+4) != 0) 
	vunchain(gs(a + 4));
    propf(".\n");
}

void *a_runiop(struct riop **hd, us f, us e)
{
    struct riop *nriop, *lriop;
    nriop = malloc(sizeof(struct riop));
    nriop->next = NULL;
    if (*hd == NULL)
	*hd = nriop;
    else
    {
	for(lriop = *hd; lriop->next != NULL; lriop = lriop->next);
	lriop->next = nriop;
    }
    nriop->flags = f;
    nriop->tnum = nriop->fnum = nriop->index = 0;
    nriop->expr = e;
    if (f == 1)
    {
	if((gb(e+1) & 0xff) == 0x22)
	{
	    nriop->tnum = gs(e+4);
	    nriop->fnum = gs(e+6);
	}
	if((gb(e+1) & 0xff) == 0x34)
	{
	    nriop->tnum = gs(e+gs(e+2));
	    nriop->fnum = gs(e+gs(e+2)+2);
	    nriop->index = gs(e+8+gs(e+2));
	}
    }
    if (f == 2)
    {
	fixv(gs(e+8), gs(e+10), NULL, gb(e+6), 0, 0, 0, "run output");
	nriop->tnum = gs(e+8);
	nriop->fnum = gs(e+10);
	nriop->index = gs(e+12);
    }
}

int runcmp(struct riop **x, struct riop **y)
{
    if((*x)->expr > (*y)->expr)
	return(1);
    if((*x)->expr < (*y)->expr)
	return(-1);
    return(0);
}

void s_run(us a)
{
    us r, cnt;
    struct riop *head = NULL, *riop, **ra;
    /* must put paramaters in here */
    propf("run value(%s)", expr(gs(gs(a+4)+4), 0));
    if (gs(a+12) != 0 || gs(a+10) != 0) 
    {
	propf(" (");
	for(r = gs(a+10); r != 0; r = gs(r))
	    a_runiop(&head, 1, gs(r+4));
	for(r = gs(a+12); r != 0; r = gs(r))
	    a_runiop(&head, 2, gs(r+4));
	cnt = 0;
	for(riop = head; riop != NULL; riop = riop->next)
	    cnt++;
	ra = malloc(sizeof(struct riop *) * (cnt+1));
	if (ra == NULL)
	    faterror("No memory for run parameter list");
	cnt = 0;
	for(riop = head; riop != NULL; riop = riop->next)
	    ra[cnt++] = riop;
	ra[cnt] = NULL;
	qsort(ra, cnt, sizeof(struct riop *), &runcmp);
	cnt = 0;
	while (ra[cnt] != NULL)
	{
	    if (ra[cnt + 1] != NULL &&
		ra[cnt]->flags == 1 &&
		ra[cnt+1]->flags == 2 &&
		ra[cnt]->tnum == ra[cnt+1]->tnum &&
		ra[cnt]->fnum == ra[cnt+1]->fnum &&
		strcmp(expr(ra[cnt]->index, 0), expr(ra[cnt+1]->index, 0)) == 0)
	    {
		ra[cnt+1]->flags = 0;
		ra[cnt]->flags = 3;
	    }
	    if (ra[cnt]->flags == 1)
		propf("%s", expr(ra[cnt]->expr, 0));
	    if (ra[cnt]->flags == 2)
		propf("output %s", vname(ra[cnt]->tnum, ra[cnt]->fnum, 0));
	    if (ra[cnt]->flags == 3)
		propf("input-output %s",vname(ra[cnt]->tnum, ra[cnt]->fnum, 0));
	    cnt++;
	    if (ra[cnt] != NULL)
		propf(", ");
	}
	propf(")");
    }
    if (gs(a+6) > 1) 
	vunchain(gs(gs(a + 4)));
    propf(".\n");
}

void s_pause(us a)
{
    propf("pause");
    if (gs(a+4) != 0)
       propf(" %s", expr(gs(a+4), 0));
    if (gs(a+6) == 1)
    {
       propf(" no-message");
    }
    if (gs(a+8) == 1)
    {
       propf(" before-hide");
    }
    if (gs(a+10) != 0)
       propf(" message \"%s\"", p + gs(a+10));
    propf(".\n");
}

void s_output(us a)
{
    char * cs;

    switch(gs(gs(a + 8) + 2))
    {
	case 0x1:  cs = "input";	    break;
	case 0x2:  cs = "output";	    break;
	case 0x3:  cs = "input-output"; break;
	default:   cs = "unknown";
    }
    if(gs(gs(a+8) + 4) == 0)
	cs = "_trace";
    propf("%s", cs);
    if (gs(a+6) != 0xffff)
	propf(" stream %s", sname(gs(a+6)));
    if ((gs(gs(a+8) + (dos?12:14)) & 0x10) != 0)
	propf(" through");
    else
	if (gs(gs(a+8) + 2) == 1)
	    propf(" from");
	else
	    propf(" to");
    if (gs(a+4) != 0) 
	vunchain(gs(a + 4));
    if ((gs(gs(a+8) + (dos?12:14)) & 0x01) != 0)
       propf(" unbuffered");
    if ((gs(gs(a+8) + (dos?12:14)) & 0x02) != 0)
       propf(" funny-opt=2");
    if ((gs(gs(a+8) + (dos?12:14)) & 0x04) != 0)
       propf(" no-echo");
    if ((gs(gs(a+8) + (dos?12:14)) & 0x08) != 0)
       propf(" paged");
    if ((gs(gs(a+8) + (dos?12:14)) & 0x20) != 0)
       propf(" echo");
    if ((gs(gs(a+8) + (dos?12:14)) & 0x40) != 0)
       propf(" append");
    if ((gs(gs(a+8) + (dos?12:14)) & 0x80) != 0)
       propf(" no-map");
    if (gs(gs(a+8) + (dos?10:12)) != 0)
       propf(" page-size %d", gs(gs(a+8)+12));
    if (gs(gs(a+8) + (dos?16:18)) != 0)
       propf(" map %s", expr(gs(gs(a+8) + (dos?16:18)), 0));
    propf(".\n");
    dbpf('s', "\n/* %04x %04x %04x %04x %04x %04x %04x %04x %04x %04x */\n\n\n",
	 gs(gs(a+8)), gs(gs(a+8)+2), gs(gs(a+8)+4), gs(gs(a+8)+6),
	 gs(gs(a+8)+8), gs(gs(a+8)+10), gs(gs(a+8)+12), gs(gs(a+8)+14),
	 gs(gs(a+8)+16), gs(gs(a+8)+18));
}

void s_output_close(us a)
{
    char * cs;

    switch(gs(a + 4))
    {
	case 0x1:  cs = "input";	    break;
	case 0x2:  cs = "output";	    break;
	case 0x3:  cs = "input-output"; break;
	default:   cs = "unknown";
    }
    propf("%s", cs);
    if (gs(a+6) != 0xffff)
	propf(" stream %s", sname(gs(a+6)));
    propf(" close.\n");
}

void s_comp(us a)
{
    if(gs(a+2) == 0xfc)
	propf("/* xcode-compile */\n");
    propf("compile");
    if (gs(a+4) != 0) 
	vunchain(gs(a + 4));
    if (gs(a+6) != 1) 
    /* this always seems to be 1, don't know why */
	propf(" (v6data not 1 - FIXME)");
    if (gb(a+15) == 1) 
	propf(" attr-space");
    if (gb(a+15) == 2) 
	propf(" no-attr-space");
    if (gs(a+18) != 0) 
	propf(" xcode %s", expr(gs(a+18), 0));
    if ((gs(a+8) & 1) == 1) 
    {
	propf(" save");
	if (gs(a+20) != 0) 
	    propf(" into value(%s)", expr(gs(a+20), 0));
    }
    if (gs(a+10) != 0) 
    {
	propf(" listing");
	vunchain(gs(a + 10));
	if ((gs(a+8) & 2) == 2) 
	    propf(" append");
	if (gs(a+12) > 0)
	    propf(" page-width %d", gs(a+12));
	if (gb(a+14) > 0)	/* should probably be gs masked (was gb)*/
	    propf(" page-size %d", gb(a+14));
    }
    if (gs(a+16) != 0) 
    {
	propf(" xref value(%s)", expr(gs(a+16), 0));
	if ((gs(a+8) & 4) == 4) 
	    propf(" append");
    }
    propf(".\n");
}

void s_opsys(us a)
{
    char * cs;

    switch(gs(a + 8))
    {
	case 0x0:  cs = "unix";	     break;
	case 0x1:  cs = "dos";	     break;
	case 0x2:  cs = "vms";	     break;
	case 0x3:  cs = "ctos/btos"; break;
	case 0x4:  cs = "os2";	     break;
	default:   cs = "unknown?";
    }
    propf("%s", cs);
    if (gs(a+6) == 1) 
	propf(" silent");
    if (gs(a+4) != 0) 
	vunchain(gs(a + 4));
    propf(".\n");
}
    
void s_block(us a)
{
    dump('L', a, 8);
    disblk(gs(a+4), -1);
}

void s_if(us a)
{
 /* wait and see if this is necessary */
/*    propf("if ", elseif?" ":indent()); */ 
    propf("if ");
    elseif = 0;
    unchain(gs(a + 4), 0);
    propf(" then\n");
    /* look ahead and only indent if not a block */
    if(gs(gs(a+6) + 2) != 0xc8)
	ind_lev++;
    if(gs(a + 6) != 0)
	unchain(gs(a + 6), 0);
    else
	propf(".");
    if(gs(gs(a+6) + 2) != 0xc8)
	ind_lev--;
    if(gs(a + 8) != 0)
    {
	propf("else");
	if(gs(gs(a+8)+2) != 0x64)
	    propf("\n");
	else
	    elseif = 1;
	if(gs(gs(a+8) + 2) != 0xc8 && gs(gs(a+8)+2) != 0x64)
	    ind_lev++;
	unchain(gs(a + 8), 0);
	if(gs(gs(a+8) + 2) != 0xc8 && gs(gs(a+8)+2) != 0x64)
	    ind_lev--;
    }
}

void disput(us a)
{
    char *p;

    dbpf('a', "\n/* %04x %04x %04x %04x */",
        gs(a), gs(a+2), gs(a+4), gs(a+6));
    if (gs(a+2) != 0)
    {
	p = expr(gs(a+2), 0);
	if(gb(a) == 0x01)
	    propf("\n    skip(%s)", p);
	if(gb(a) == 0x02)
	    propf("\n    space(%s)", p);
	if(gb(a) == 0x03)
	    propf("\n    %s", p);
	if(gb(a) == 0x04)
	    propf("\n    null(%s)", p);
    }
    else
    {
	if(gb(a) == 0x01)
	    propf("\n    skip");
	if(gb(a) == 0x02)
	    propf("\n    space");
    }

    if (gs(a+4) != 0)
	propf(" %s format %s", expr(gs(a+4), 0));
    if (gs(a+6) != 0)
    {
	propf(" %s", (gb(a+1) & 1) == 1 ? "to":"at");
	propf(" %s", expr(gs(a+6), 0));
    }
     
    if(gs(a) == 0 && gs(a+2) == 0)
	 return;
    disput(a+8);
}

void disblk(us a, int lt)
{
    int save_blk, ind_save;
    int ltype; /* 0 = procedure, 1 = do, 2 = repeat, 3 = for, 4 = editing,
		  -1 dont't know */
    char *ld, *by, *to, *from, *var = NULL;
    us ad;
    us blknum, blklev, init, recstuff, control, stmnts, validate, rel1,
       o_endkey, o_error, rel2, trnflg, itflg, systran, istran;
    to = "";
    blknum = gs(a);
    blklev = gs(a+2);
    init = gs(a+4);
    recstuff = gs(a+6);
    control = gs(a+8);
    o_endkey = gs(a+16);
    o_error = gs(a+18);

    if (a == 0)
    {
       propf("/* null block */\n");
       return;
    }
    ltype = lt;
    if (ltype == -1)
    {
	if (recstuff == 0 && (o_endkey == 0 || o_error == 0))
	    ltype = 1;
	else
	    if (recstuff == 0)
		ltype = 2;
	    else
		ltype = 3;
    }
    switch(ltype)
    {
	case 0:  ld = ""; 	  break;
	case 1:  ld = "do"; 	  break;
	case 2:  ld = "repeat";   break;
	case 3:  ld = "for"; 	  break;
	case 4:  ld = "editing";  break;
	default: ld = "unknown";
    }
    if (Ldebug)
	printf("/* loop level %03d */\n", blklev);
    if (Ldebug)
	d_disblk(a);
    save_blk = curr_blk;
    curr_blk = blknum;
    if (blknum > 0)
    {
	if ((loops[blknum] & L_NAMED) > 0) 
	    propf("LOOP-%03d:\n", blknum);
	ind_lev++;
    }
    else 
	propf("/*\n");
    dump('L', a, 44);
    if (recstuff != 0)
    {
	propf("\n/*\n");
	propf("RECORD STUFF\n");
	if (gs(recstuff + 2) != 0)
	{
	    macros = malloc(sizeof(char *) * gs(recstuff + 14));
	    macro_cnt = 0;
	    unchain(gs(recstuff + 2), 0);
	}
	if (gs(recstuff + 6) != 0)
	    unchain(gs(recstuff + 6), 0);
	if (gs(recstuff + 4) != 0)
	    unchain(gs(recstuff + 4), 0);
	propf("\n*/\n");
    }
    if (init != 0)
    {
	dbpf('s', "\nblk: (a+4)\n");
	ad = gs(gs(init+4));
	var = vname(gs(gs(init+4)+8), gs(gs(init+4)+10), 0);
	from = expr(ad + (dos?6:8), 0);
	by = expr(ad + (dos?6:8) + gs(ad+2), 0);
    }
    if (control != 0 && init != 0)
    {
	dbpf('s', "\nblk: (a+8)\n");
    /* dont need this stuff but may check it later */
/* 	ad = gs(gs(control+4)); */
/*  	by = expr(ad + (dos?6:8) + gs(ad+2), 0);  */
 	ad = gs(gs(control)+4);
  	to = expr(ad + (dos?6:8) + gs(ad+2), 0); 
    }
    if (gs(a+14) != 0)
    {
	propf("\n/* release 1\n");
	unchain(gs(a + 14), 0);
	propf("*/\n");
    }
    if (gs(a+20) != 0)
    {
	propf("\n /* release 2\n");
	unchain(gs(a + 20), 0);
	propf("*/\n");
    }
    ind_lev--;
    propf("\n%s", ld);
    ind_lev++;
    if (var != NULL)
	propf("\n%s = %s to %s by %s", var, from, to, by);
    if (control != 0 && (init == 0 || gs(gs(control))!= 0))
    {
	propf ("\nwhile ");
	unchain(control, -1);
    }
    if (o_endkey != 0 &&
	(ltype == 1 ||
	 gs(o_endkey + 4) != curr_blk ||
	 gs(o_endkey + 6) != curr_blk ||
	 gs(o_endkey + 8) != 0xf752))
    {
	propf("\non endkey ");
	ind_save = ind_lev;
	ind_lev = 0;
	loop_ctl = 1;
	unchain(o_endkey, 0);
	loop_ctl = 0;
	ind_lev = ind_save;
    }
    if (o_error != 0 &&
	(ltype == 1 ||
	 gs(o_error + 4) != curr_blk ||
	 gs(o_error + 6) != curr_blk ||
	 gs(o_error + 8) != 0xe865)) 
    {
	propf("\non error ");
	ind_save = ind_lev;
	ind_lev = 0;
	loop_ctl = 1;
	unchain(o_error, 0);
	loop_ctl = 0;
	ind_lev = ind_save;
    }
    if (ltype > 0)
	propf(":\n");
    else
	propf(" */\n");
    unchain(gs(a + 10), 0);
    if (blknum > 0) 
    {
	ind_lev--;
	propf("end.\n");
    }
    curr_blk = save_blk;
    macros = NULL;
}

void s_notdone(us a, char *s)
{
    propf(" not done %s at %04x.\n", s, a);
    dump('s', a, 64);
}

void s_sql1(us a)
{
    propf("(?? sql %04x %04x).\n", gs(a+4), gs(a+6));
}

void s_sql2(us a)
{
    propf("(?? sql release).\n");
}

void s_bad(us a, char *s)
{
    propf("bad %4x @ %04x %s.\n", gs(a+2), a, s);
}

void s_nop(us a)
{
    propf("/**** illegal ****/ nop at %04x.\n", a);
}

void s_ivalue(us a)
{
    us t, l, len, ptr, i;
    t = gs(a+4);
    l = gs(a+6);
    len = gs(a+8);
    ptr = l;
    i = 1;
    if (vdebug)
	printf("s_ival: %04x list %d @ %04x length %04x \n", a, t, l, len);
    while (ptr < l + len)
    {
	if (vdebug)
	    printf("s_ival: t = %d, f= %d ival @ %04x -> %04x, %04x\n",
		t, i, ptr, gb(ptr), gb(ptr) == 0xfa? gs(ptr+1): 0);
	dump('v', ptr, gb(ptr)==0xfa?gs(ptr+1)+3:gb(ptr)+1);
	fixv(t, i, NULL, 0, 0, 0, ptr, "ivalue");
	switch(gb(ptr))
	{
	   case 0xe6:
		      ptr += 3 + gs(ptr + 1);
		      break;
	   case 0xe7:
		      printf("/* Ivalue %02x junk discarded */\n", gb(ptr));
		      ptr += 4 + gb(ptr+2);
		      break;
	   case 0xfa:
		      ptr += 3 + gs(ptr + 1);
		      break;
	   case 0xfd:
		      ptr += 1;
		      break;
	   default:
		      ptr += gb(ptr) + 1;
		      break;
	}
	i++;
    }
}
