/* test.pro -- test program for use with demo.db */

define variable a as character extent 12 
    initial ["a", "b", "c", "d", "e", "f", "g", "h", "i", "j", "k", "l"].
define variable c as character initial ">cccccc<".
define variable s as character.
define variable i as integer.
define variable j as integer.
define variable k as integer.
define variable f as decimal.
define variable d as date.
define variable l as logical initial yes.
define variable r as recid.
define variable w as raw.
define variable n as integer no-undo initial 99.
define new global shared variable ngsv-a as character.
define new global shared variable ngsv-b as integer extent 7.
define new global shared variable ngsv-c as date no-undo.
define new shared variable nsv-a as date no-undo.
define new shared variable nsv-b as integer initial 77.
define shared variable sv-a as decimal.
define shared variable sv-b as decimal decimals 5.
define shared variable sv-c as decimal decimals 7.
define shared variable sv-d as decimal extent 9.
define shared variable sv-e as raw.

define new global shared stream ngss-s.
define new shared stream nss-s.
define shared stream ss-s.
define stream s-s.

define buffer c-buf for customer.
define shared buffer nc-buf for customer.
define new shared buffer nsc-buf for customer.

define workfile wf-cred no-undo
    field wfcr-name as character
    field wfcr-balance as decimal.

define workfile wf-cust
    field wfcu-name as character
    field wfcu-balance as decimal.

define input parameter ip-a as integer.
define output parameter op-a as character.
define input parameter ip-b as date.
define input-output parameter iop-a as integer.

define new shared frame nsf-z.
define shared frame sf-y.

/* make sure nobody runs this garbage */
stop.

/* some find testing */
find first customer exclusive-lock.
find last customer.
find next customer share-lock.
find prev customer no-lock.
find customer where customer.cust-num = 7 no-lock.
find customer where customer.cust-num = 7 and customer.zip > 3 no-lock no-error.
find first customer where customer.zip > 3 no-lock no-error.

for first customer:
    bell.
end.
for last customer:
    bell.
end.
for each customer:
    display customer.
    bell.
    quit.
    stop.
    next.
    leave.
    return.
    undo, retry.
    run test.p (i, output c, d, input-output i).
end.
for each customer 
    where customer.cust-num > 3 
    by customer.cust-num descending:
    bell.
end.

for each customer,
    each order of customer:
    display customer.cust-num order-num.
end.
R-BLOCK:
repeat:
    ngsv-a = a[i].
    nsv-a = d.
    a[i] = c.
    c = string(d).
    prompt-for
       c.
    i = integer(input c).
    assign
       i = integer(d)
       d = today
       c.
    message "foo" update c.
    c = if i = 3 then "foo bar" else c.
    repeat:
	if i > 7 then
	    next R-BLOCK.
	else
	do:
	    for each customer.
		display customer.cust-num customer.name.
	    end.
	    choose row customer.cust-num.
	    choose row customer.cust-num pause time.
	    choose row customer.cust-num no-error.
	end.
	bell.
    end.
end.
do:
   bell.
end.
do while i > 3:
   bell.
end.
do j = 1 to 5 by 2:
   bell.
end.
do i = j + k to time by -7:
   bell.
end.
do j = 1 to 5 by 2 while i > 3:
   bell.
end.

/* 0x2c9 stuff */
a = c.
display i j with frame f-f.
display 
    i when  j > 7 @ j
with frame f-f.
display 
    a[1 for 2]
    c when a[3] <> ""
    i when  j > 7 @ j
    j when  j = 7
    k when  j < 7 @ j
    with frame f-f.

/* input/output stuff */
output to terminal.
output to printer.
output stream s-s to "fred".
output stream s-s close.
output stream s-s through "fred".
output stream s-s close.
input stream s-s from "fred".
input stream s-s close.
input stream s-s through "fred".
input stream s-s close.

/* undocumented statements */
i = _serial-num.
i = _msg(i).
l = _cbit(c, i).
c = _control.
_trace on.
_trace off.

/* tests on all operators and fucntions */

i = i + 1.
i = i - 1.
i = i * 1.
i = i / 1.
i = + i.
i = - i.
i = minimum(1, 2).
i = maximum(1, 2).
f = sqrt(f).
i = round(f, 2).
i = truncate(f, 2).
l = i > j.
l = i < j.
l = i = j.
l = i <> j.
l = i >= j.
l = i <= j.
l = not true.
l = false and true.
l = false or true.
c = substring("string", 1, 2).
c = substring("string", 1).
i = length(c).
i = index(c, a[1]).
l = a[1] matches c.
i = month(d).
i = day(d).
i = year(d).
i = weekday(d).
i = integer(d).
i = integer(f).
i = integer(c).
c = string(i).
c = string(i, "HH:MM:SS").
c = string(d, "99/99/99").
d = date(i, j, k).
f = decimal(i).
f = decimal(c).
i = j.
prompt-for j with frame z.
prompt-for j a with frame z-2.
i = input j.
c = input a[3].
c = input a[i].
c = input a[time].
i = input frame z j.
i = 1.
i = j modulo 5.
i = if i = 3 then 5 else 4.
find first customer.
r = recid(customer).
l = available customer.
d = today.
i = random(7, 2709).
c = caps("zzz").
c = lc("ZZZ").
f = exp(10, 2.3).
l = j entered.
l = a[1] entered.
l = a[i] entered.
l = frame z-2 j entered.
l = frame z j entered.
l = new customer.
l = ambiguous customer.
f = log(10, 2.3).
f = log(10).
c = a[3].
c = userid.
c = userid(c).
c = userid("demo").
c = dbname.
l = j not entered.
l = frame z-2 j not entered.
l = c begins a[3].
l = retry.
c = search(c).
i = line-counter.
i = line-counter(s-s).
i = page-size.
i = page-size(s-s).
l = locked customer.
l = can-do(s, c).
s = kblabel(c).
i = page-number.
i = page-number(s-s).
i = time.
s = opsys.
i = lastkey.
s = terminal.
s = chr(i).
i = asc(s).
i = message-lines.
i = screen-lines.
s = frame-field.
s = frame-file.
s = frame-value.
i = keycode(s).
s = keyfunction(i).
s = keylabel(i).
l = go-pending.
i = lookup("abc", "abc,def,ghi").
s = entry(i, "abc,def,ghi").
s = fill("expr", i).
l = can-find(customer 9).
l = can-find(customer where customer.cust-num = 9).
l = can-find(first customer where customer.cust-num = 9).
l = can-find(last customer where customer.cust-num = 9).
i = frame-col(z).
i = frame-down(z).
i = frame-line(z).
i = frame-row(z).
s = encode(c).
l = setuserid(s, c, a[i]).
l = setuserid(s, c).
for each customer break by customer.st:
    i = count-of(customer.st).
end.
c = keyword("fred").
s = progress.
substring(c, i) = "fred".
substring(c, i, j) = "fred".
substring(c, i, j) = substring(c, i, j).
substring(a[i], i, j) = "joe".
substring(a[i], i) = "charlie".
overlay(c, i) = "fred".
overlay(c, i, j) = "fred".
overlay(c, i, j) = substring(c, i, j).
overlay(a[i], i, j) = "joe".
overlay(a[i], i) = "charlie".
/* version6 */
s = ldbname(i).
s = ldbname(c).
s = pdbname(i).
s = pdbname(c).
s = dbtype(i).
s = dbtype(c).
s = frame-db.
i = frame-index.
s = frame-name.
i = seek(input).
i = seek(output).
i = seek(s-s).
c = trim(s).
l = is-attr-space.
i = r-index(c, a[1]).
i = num-dbs.
s = dbrestrictions(i).
s = dbrestrictions(c).
i = num-aliases.
s = gateways.
/* case-sensitive */
s = dbversion(i).
s = dbversion(c).
s = program-name(i).
s = sdbname(i).
s = sdbname(c).
s = propath.
i = num-entries(s).
s = alias(i).

s = library(c).
s = member(c).

#if MINV >= 2
#if MINV > 2 || LEVEL > 3
getbyte
putbyte
length(w) = 3.
w = raw(f).
raw stmnt
i = etime.
#endif
#endif

propath = "x".
terminal = "x".

/* check nesting */

i = j - k + i.
i = (j - k) + i.
i = j - (k + i).
i = j + k * i.
i = (j + k) * i.
i = j + (k * i).
l = l and l or l.
l = l and (l or l).
l = (l and l) or l.
l = l or l and l.
l = (l or l) and l.
l = l or (l and l).
l = not l or (l and l).
l = not (l or (l and l)).
